%define DATE 20080414
%define gcc_version 4.1.2
%define gcc_release 42
%define _unpackaged_files_terminate_build 0
%define multilib_64_archs sparc64 ppc64 s390x x86_64
%define build_java 1
%define gxx_primary_version 3.4.3
%ifarch s390x
%define multilib_32_arch s390
%endif
%ifarch sparc64
%define multilib_32_arch sparc
%endif
%ifarch ppc64
%define multilib_32_arch ppc
%endif
%ifarch x86_64
%define multilib_32_arch i386
%endif
Summary: Preview of GCC version 4.1
Name: gcc4
Version: %{gcc_version}
Release: 42.EL4
License: GPL
Group: Development/Languages
Source0: gcc-%{version}-%{DATE}.tar.bz2
Source1: libgcc_post_upgrade.c
Source2: libgfortran-4.0.0-20041214.tar.bz2
Source3: libgfortran-4.0.2-20051130.tar.bz2
URL: http://gcc.gnu.org
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root
# Need binutils with -pie support >= 2.14.90.0.4-4
# Need binutils which can omit dot symbols and overlap .opd on ppc64 >= 2.15.91.0.2-4
# Need binutils with .weakref support
BuildRequires: binutils >= 2.15.92.0.2-18
# Need binutils with -pie support
# Need --as-needed/--no-as-needed support
# On ppc64, need omit dot symbols support and --non-overlapping-opd
# Need .weakref support
Requires: binutils >= 2.15.92.0.2-18
BuildRequires: zlib-devel, gettext, dejagnu, bison, flex, texinfo, sharutils
BuildRequires: /usr/bin/fastjar
# Make sure pthread.h doesn't contain __thread tokens
BuildRequires: glibc-devel >= 2.2.90-12
BuildRequires: elfutils-devel >= 0.72
%ifarch %{multilib_64_archs} sparc ppc
# Ensure glibc{,-devel} is installed for both multilib arches
BuildRequires: /lib/libc.so.6 /usr/lib/libc.so /lib64/libc.so.6 /usr/lib64/libc.so
%endif
%ifarch ia64
BuildRequires: libunwind >= 0.98
%endif
# Need .eh_frame ld optimizations
# Need proper visibility support
# Need -pie support
Requires: binutils >= 2.14.90.0.4-4
# Make sure gdb will understand DW_FORM_strp
Conflicts: gdb < 5.1-2
Requires: glibc-devel >= 2.2.90-12
Requires: libgcc >= 3.3.2-7
Requires: libgomp = %{version}-%{release}
Prereq: /sbin/install-info
AutoReq: true
Obsoletes: gcc35

Patch1: gcc41-ice-hack.patch
Patch2: gcc41-ppc64-m32-m64-multilib-only.patch
Patch3: gcc41-ia64-libunwind.patch
Patch4: gcc41-gnuc-rh-release.patch
Patch5: gcc41-java-nomulti.patch
Patch6: gcc41-ada-pr18302.patch
Patch7: gcc41-ada-tweaks.patch
Patch8: gcc41-java-slow_pthread_self.patch
Patch9: gcc41-ppc32-retaddr.patch
Patch10: gcc41-dsohandle.patch
Patch11: gcc41-rh184446.patch
Patch12: gcc41-pr20297-test.patch
Patch13: gcc41-hash-style-gnu.patch
Patch14: gcc41-java-libdotdotlib.patch
Patch15: gcc41-pr28755.patch
Patch16: gcc41-pr27898.patch
Patch17: gcc41-pr29703.patch
Patch18: gcc41-libjava-anonverscript.patch
Patch19: gcc41-ppc64-libffi-unwind.patch
Patch20: gcc41-pr30110.patch
Patch21: gcc41-pr32139.patch
Patch22: gcc41-rh235008.patch
Patch23: gcc41-ppc64-ia64-GNU-stack.patch
Patch24: gcc41-pr28690.patch
Patch25: gcc41-pr33506.patch
Patch26: gcc41-artificial-attrib.patch
Patch27: gcc41-error-attrib.patch
Patch28: gcc41-rh247256.patch
Patch30: gcc41-pr20880.patch
Patch31: gcc41-pr32694.patch
Patch32: gcc41-virtual-inline-backtrace.patch
Patch33: gcc41-c++-gnu-inline-redecl.patch
Patch34: gcc41-c++-builtin-redecl.patch
Patch36: gcc41-pr32121.patch
Patch37: gcc41-pr33136.patch
Patch38: gcc41-pr33238.patch
Patch39: gcc41-pr33619.patch
Patch42: gcc41-pr33763.patch
Patch43: gcc41-rh317051.patch
Patch55: gcc41-pr23848.patch
Patch56: gcc41-pr29225.patch
Patch57: gcc41-pr29712.patch
Patch58: gcc41-pr30293.patch
Patch59: gcc41-pr30988.patch
Patch60: gcc41-pr32241.patch
Patch61: gcc41-pr32384.patch
Patch62: gcc41-pr33501.patch
Patch63: gcc41-pr33516.patch
Patch64: gcc41-pr33537.patch
Patch65: gcc41-pr33616.patch
Patch66: gcc41-pr33723.patch
Patch67: gcc41-pr33836.patch
Patch68: gcc41-pr33842.patch
Patch69: gcc41-pr33844.patch
Patch70: gcc41-pr33962.patch
Patch71: gcc41-pr34070.patch
Patch72: gcc41-pr34089.patch
Patch73: gcc41-pr34178.patch
Patch74: gcc41-pr34130.patch
Patch75: gcc41-pr34146.patch
Patch76: gcc41-rh364001.patch
Patch78: gcc41-pr34364.patch
Patch79: gcc41-pr34275.patch
Patch80: gcc41-rh407281.patch
Patch81: gcc41-pr34394.patch
Patch82: gcc41-debug-fortran-array.patch
Patch83: gcc41-omp-outer-ctx.patch
Patch84: gcc41-pr27643.patch
Patch85: gcc41-pr29978.patch
Patch86: gcc41-pr31483.patch
Patch87: gcc41-pr33890.patch
Patch88: gcc41-pr34506.patch
Patch89: gcc41-pr34513.patch
Patch90: gcc41-pr7081.patch
Patch91: gcc41-rh426846.patch
Patch92: gcc41-sse5.patch
Patch93: gcc41-sse5-pperm.patch
Patch94: gcc41-rh369541-1.patch
Patch95: gcc41-rh369541-2.patch
Patch96: gcc41-pr33275.patch
Patch97: gcc41-rh251682.patch

Patch200: gcc41-pr21764.patch
Patch201: gcc41-pr21581.patch
Patch202: gcc41-java-pr13212.patch
Patch203: gcc41-rh235371.patch
Patch204: gcc41-pr31842.patch

Patch250: gcc41-c++-pr10606-revert.patch
Patch251: gcc41-libstdc++-hack.patch
Patch252: gcc41-libjava-gcj4-dbexecdir.patch
Patch253: gcc41-libgfortranpreview-Idot.patch

%define _gnu 5E
%ifarch sparc
%define gcc_target_platform sparc64-%{_vendor}-%{_target_os}%{?_gnu}
%define gcc_primary_target_platform sparc64-%{_vendor}-%{_target_os}
%endif
%ifarch ppc
%define gcc_target_platform ppc64-%{_vendor}-%{_target_os}%{?_gnu}
%define gcc_primary_target_platform ppc64-%{_vendor}-%{_target_os}
%endif
%ifnarch sparc ppc
%define gcc_target_platform %{_target_platform}
%define gcc_primary_target_platform %{_target_cpu}-%{_vendor}-%{_target_os}
%endif

%description
The gcc4 package contains preview of the GNU Compiler Collection version 4.1.

%package c++
Summary: C++ support for GCC version 4.1 preview
Group: Development/Languages
Requires: gcc4 = %{version}-%{release}
BuildRequires: gcc-c++ = %{gxx_primary_version}
Requires: gcc-c++ >= 3.4.4-2
Requires: libstdc++ = %{gxx_primary_version}
Requires: libstdc++-devel = %{gxx_primary_version}
Autoreq: true
Obsoletes: gcc35-c++

%description c++
This package adds C++ support to the GNU Compiler Collection.
It includes support for most of the current C++ specification,
including templates and exception handling.

%package gfortran
Summary: Fortran 95 support
Group: Development/Languages
Requires: gcc4 = %{version}-%{release}
Requires: libgfortran = %{version}-%{release}
BuildRequires: gmp-devel >= 4.1.2-8
Prereq: /sbin/install-info
Autoreq: true
Obsoletes: gcc35-gfortran

%description gfortran
The gcc4-gfortran package provides a preview of Fortran 95
compiler from the GNU Compiler Collection.

%package -n libgfortran
Summary: Fortran 95 runtime
Group: System Environment/Libraries
Autoreq: true

%description -n libgfortran
This package contains Fortran 95 shared library which is needed to run
dynamically linked programs created with the Fortran 95 preview
compiler.

%package -n libgomp
Summary: GCC OpenMP 2.5 shared support library
Group: System Environment/Libraries

%description -n libgomp
This package contains GCC shared support library which is needed
for OpenMP 2.5 support.

%package -n libmudflap
Summary: GCC mudflap shared support library
Group: System Environment/Libraries

%description -n libmudflap
This package contains GCC shared support library which is needed
for mudflap support.

%package -n libmudflap-devel
Summary: GCC mudflap support
Group: Development/Libraries
Requires: libmudflap = %{version}-%{release}
Requires: gcc4 = %{version}-%{release}

%description -n libmudflap-devel
This package contains headers and static libraries for building
mudflap-instrumented programs.

To instrument a non-threaded program, add -fmudflap
option to GCC and when linking add -lmudflap, for threaded programs
also add -fmudflapth and -lmudflapth.

%package java
Summary: Java support for GCC4 preview
Group: Development/Languages
Requires: gcc4 = %{version}-%{release}
Requires: libgcj4 = %{version}-%{release}, libgcj4-devel = %{version}-%{release}, zlib-devel
Prereq: /sbin/install-info
Autoreq: true

%description java
This package adds support for compiling Java(tm) programs and
bytecode into native code.

%package -n libgcj4
Summary: Java runtime library for GCC4 preview
Group: System Environment/Libraries
Prereq: /sbin/install-info
Requires: zip >= 2.1
Requires: gtk2 >= 2.4.0
BuildRequires: gtk2-devel >= 2.4.0
Requires: glib2 >= 2.4.0
BuildRequires: glib2-devel >= 2.4.0
Requires: libart_lgpl >= 2.1.0
BuildRequires: libart_lgpl-devel >= 2.1.0
BuildRequires: alsa-lib-devel
Autoreq: true

%description -n libgcj4
The Java(tm) runtime library. You will need this package to run your Java
programs compiled using the Java compiler from GNU Compiler Collection
(gcj).

%package -n libgcj4-devel
Summary: Libraries for Java development using GCC
Group: Development/Languages
Requires: libgcj4 = %{version}-%{release}, %{_prefix}/%{_lib}/libgcj.so.7
Requires: zlib-devel, %{_prefix}/%{_lib}/libz.so
Requires: /bin/awk
Autoreq: true

%description -n libgcj4-devel
The Java(tm) static libraries and C header files. You will need this
package to compile your Java programs using the GCC Java compiler (gcj4).

%package -n libgcj4-src
Summary: Java library sources from GCC4 preview
Group: System Environment/Libraries
Requires: libgcj4 = %{version}-%{release}
Autoreq: true

%description -n libgcj4-src
The Java(tm) runtime library sources for use in Eclipse.

%prep
%setup -q -n gcc-%{version}-%{DATE}
%patch1 -p0 -b .ice-hack~
%patch2 -p0 -b .ppc64-m32-m64-multilib-only~
%patch3 -p0 -b .ia64-libunwind~
%patch4 -p0 -b .gnuc-rh-release~
%patch5 -p0 -b .java-nomulti~
%patch6 -p0 -b .ada-pr18302~
%patch7 -p0 -b .ada-tweaks~
%patch8 -p0 -b .java-slow_pthread_self~
%patch9 -p0 -b .ppc32-retaddr~
%patch10 -p0 -b .dsohandle~
%patch11 -p0 -b .rh184446~
%patch12 -p0 -E -b .pr20297-test~
#%patch13 -p0 -b .hash-style-gnu~
%patch14 -p0 -b .java-libdotdotlib~
%patch15 -p0 -b .pr28755~
%patch16 -p0 -b .pr27898~
#%patch17 -p0 -b .pr29703~
#%patch18 -p0 -b .libjava-anonverscript~
%patch19 -p0 -b .ppc64-libffi-unwind~
%patch20 -p0 -b .pr30110~
%patch21 -p0 -b .pr32139~
%patch22 -p0 -b .rh235008~
%patch23 -p0 -b .ppc64-ia64-GNU-stack~
%patch24 -p0 -b .pr28690~
%patch25 -p0 -b .pr33506~
%patch26 -p0 -b .artificial-attrib~
%patch27 -p0 -b .error-attrib~
%patch28 -p0 -b .rh247256~
%patch30 -p0 -b .pr20880~
%patch31 -p0 -b .pr32694~
%patch32 -p0 -b .virtual-inline-backtrace~
%patch33 -p0 -b .c++-gnu-inline-redecl~
%patch34 -p0 -b .c++-builtin-redecl~
%patch36 -p0 -b .pr32121~
%patch37 -p0 -b .pr33136~
%patch38 -p0 -b .pr33238~
%patch39 -p0 -b .pr33619~
%patch42 -p0 -b .pr33763~
%patch43 -p0 -b .rh317051~
%patch55 -p0 -b .pr23848~
%patch56 -p0 -b .pr29225~
%patch57 -p0 -b .pr29712~
%patch58 -p0 -b .pr30293~
%patch59 -p0 -b .pr30988~
%patch60 -p0 -b .pr32241~
%patch61 -p0 -b .pr32384~
%patch62 -p0 -b .pr33501~
%patch63 -p0 -b .pr33516~
%patch64 -p0 -b .pr33537~
%patch65 -p0 -b .pr33616~
%patch66 -p0 -b .pr33723~
%patch67 -p0 -b .pr33836~
%patch68 -p0 -b .pr33842~
%patch69 -p0 -b .pr33844~
%patch70 -p0 -b .pr33962~
%patch71 -p0 -b .pr34070~
%patch72 -p0 -b .pr34089~
%patch73 -p0 -b .pr34178~
%patch74 -p0 -b .pr34130~
%patch75 -p0 -b .pr34146~
%patch76 -p0 -b .rh364001~
%patch78 -p0 -b .pr34364~
%patch79 -p0 -b .pr34275~
%patch80 -p0 -b .rh407281~
%patch81 -p0 -b .pr34394~
%patch82 -p0 -b .debug-fortran-array~
%patch83 -p0 -b .omp-outer-ctx~
%patch84 -p0 -b .pr27643~
%patch85 -p0 -b .pr29978~
%patch86 -p0 -b .pr31483~
%patch87 -p0 -b .pr33890~
%patch88 -p0 -b .pr34506~
%patch89 -p0 -b .pr34513~
%patch90 -p0 -b .pr7081~
%patch91 -p0 -b .rh426846~
%patch92 -p0 -b .sse5~
%patch93 -p0 -b .sse5-pperm~
%patch94 -p0 -b .rh369541-1~
%patch95 -p0 -b .rh369541-2~
%patch96 -p0 -b .pr33275~
%patch97 -p0 -b .rh251682~

%patch200 -p0 -b .pr21764~
#%patch201 -p0 -b .pr21581~
%patch202 -p0 -b .java-pr13212~
%patch203 -p0 -b .rh235371~
%patch204 -p0 -b .pr31842~

%patch250 -p0 -b .c++-pr10606-revert~
%patch251 -p0 -b .libstdc++-hack~
%patch252 -p0 -b .libjava-gcj4-dbexecdir~

mkdir libgfortranpreview
cd libgfortranpreview
tar xjf %{SOURCE2}
mv -f libgfortran/* libgfortran/.[a-zA-Z]* .
rmdir libgfortran
%patch253 -p1 -b .libgfortranpreview-Idot~
cd ..

mkdir libgfortran0
cd libgfortran0
tar xjf %{SOURCE3}
mv -f libgfortran/* .
rmdir libgfortran
cd ..

sed -i -e 's/4\.1\.3/4.1.2/' gcc/BASE-VER gcc/version.c
sed -i -e 's/" (Red Hat[^)]*)"/" (Red Hat %{version}-%{gcc_release})"/' gcc/version.c

sed -i -e 's/libjawt/libgcjawt/g' libjava/Makefile.{am,in}

cp -a libstdc++-v3/config/cpu/i{4,3}86/atomicity.h

# Hack to avoid building multilib libjava
perl -pi -e 's/^all: all-redirect/ifeq (\$(MULTISUBDIR),)\nall: all-redirect\nelse\nall:\n\techo Multilib libjava build disabled\nendif/' libjava/Makefile.in
perl -pi -e 's/^install: install-redirect/ifeq (\$(MULTISUBDIR),)\ninstall: install-redirect\nelse\ninstall:\n\techo Multilib libjava install disabled\nendif/' libjava/Makefile.in
perl -pi -e 's/^check: check-redirect/ifeq (\$(MULTISUBDIR),)\ncheck: check-redirect\nelse\ncheck:\n\techo Multilib libjava check disabled\nendif/' libjava/Makefile.in
perl -pi -e 's/^all: all-recursive/ifeq (\$(MULTISUBDIR),)\nall: all-recursive\nelse\nall:\n\techo Multilib libjava build disabled\nendif/' libjava/Makefile.in
perl -pi -e 's/^install: install-recursive/ifeq (\$(MULTISUBDIR),)\ninstall: install-recursive\nelse\ninstall:\n\techo Multilib libjava install disabled\nendif/' libjava/Makefile.in
perl -pi -e 's/^check: check-recursive/ifeq (\$(MULTISUBDIR),)\ncheck: check-recursive\nelse\ncheck:\n\techo Multilib libjava check disabled\nendif/' libjava/Makefile.in

perl -pi -e 's/libgfortran(\.la|_la|inc|\.a)/libgfortranpreview$1/g' libgfortranpreview/Makefile.am libgfortranpreview/Makefile.in

./contrib/gcc_update --touch

%ifarch ppc
if [ -d libstdc++-v3/config/abi/powerpc64-linux-gnu ]; then
  mkdir -p libstdc++-v3/config/abi/powerpc64-linux-gnu/64
  mv libstdc++-v3/config/abi/powerpc64-linux-gnu/{,64/}baseline_symbols.txt
  mv libstdc++-v3/config/abi/powerpc64-linux-gnu/{32/,}baseline_symbols.txt
  rm -rf libstdc++-v3/config/abi/powerpc64-linux-gnu/32
fi
%endif
%ifarch sparc
if [ -d libstdc++-v3/config/abi/sparc64-linux-gnu ]; then
  mkdir -p libstdc++-v3/config/abi/sparc64-linux-gnu/64
  mv libstdc++-v3/config/abi/sparc64-linux-gnu/{,64/}baseline_symbols.txt
  mv libstdc++-v3/config/abi/sparc64-linux-gnu/{32/,}baseline_symbols.txt
  rm -rf libstdc++-v3/config/abi/sparc64-linux-gnu/32
fi
%endif

%build

rm -fr obj-%{gcc_target_platform}
mkdir obj-%{gcc_target_platform}
cd obj-%{gcc_target_platform}

if [ ! -f /usr/lib/locale/de_DE/LC_CTYPE ]; then
  mkdir locale
  localedef -f ISO-8859-1 -i de_DE locale/de_DE
  export LOCPATH=`pwd`/locale:/usr/lib/locale
fi

CC=gcc
OPT_FLAGS=`echo $RPM_OPT_FLAGS|sed -e 's/-fno-rtti//g' -e 's/-fno-exceptions//g'`
OPT_FLAGS=`echo $OPT_FLAGS|sed -e 's/\(-Wp,\)\?-D_FORTIFY_SOURCE=[12]//g'`
OPT_FLAGS=`echo $OPT_FLAGS|sed -e 's/-m64//g;s/-m32//g;s/-m31//g'`
%ifarch sparc sparc64
OPT_FLAGS=`echo $OPT_FLAGS|sed -e 's/-mcpu=ultrasparc/-mtune=ultrasparc/g;s/-mcpu=v[78]//g'`
%endif
%ifarch %{ix86}
OPT_FLAGS=`echo $OPT_FLAGS|sed -e 's/-mcpu=/-mtune=/g'`
%endif
%ifarch sparc64
cat > gcc64 <<"EOF"
#!/bin/sh
exec /usr/bin/gcc -m64 "$@"
EOF
chmod +x gcc64
CC=`pwd`/gcc64
%endif
%ifarch ppc64
if gcc -m64 -xc -S /dev/null -o - > /dev/null 2>&1; then
  cat > gcc64 <<"EOF"
#!/bin/sh
exec /usr/bin/gcc -m64 "$@"
EOF
  chmod +x gcc64
  CC=`pwd`/gcc64
fi
%endif
OPT_FLAGS=`echo "$OPT_FLAGS" | sed -e 's/[[:blank:]]\+/ /g'`
case "$OPT_FLAGS" in
  *-fasynchronous-unwind-tables*)
    sed -i -e 's/-fno-exceptions /-fno-exceptions -fno-asynchronous-unwind-tables/' \
      ../gcc/Makefile.in
    ;;
esac
CC="$CC" CFLAGS="$OPT_FLAGS" CXXFLAGS="$OPT_FLAGS" XCFLAGS="$OPT_FLAGS" TCFLAGS="$OPT_FLAGS" \
	GCJFLAGS="$OPT_FLAGS" \
	../configure --prefix=%{_prefix} --mandir=%{_mandir} --infodir=%{_infodir} \
	--enable-shared --enable-threads=posix --enable-checking=release \
	--with-system-zlib --enable-__cxa_atexit --disable-libunwind-exceptions \
	--with-gxx-include-dir=/usr/include/c++/%{gxx_primary_version} \
	--enable-libgcj-multifile \
%if !%{build_java}
	--enable-languages=c,c++,f95 \
	--disable-libgcj \
%else
	--enable-languages=c,c++,java,f95 \
	--enable-java-awt=gtk --disable-dssi \
	--with-java-home=%{_prefix}/lib/jvm/java-1.4.2-gcj-1.4.2.0/jre \
%endif
%ifarch sparc
	--host=%{gcc_target_platform} --build=%{gcc_target_platform} --target=%{gcc_target_platform} --with-cpu=v7
%endif
%ifarch ppc
	--host=%{gcc_target_platform} --build=%{gcc_target_platform} --target=%{gcc_target_platform} --with-cpu=default32
%endif
%ifarch %{ix86} x86_64
	--with-cpu=generic \
%endif
%ifnarch sparc ppc
	--host=%{gcc_target_platform}
%endif

%ifarch %{ix86} x86_64 ppc ppc64
GCJFLAGS="$OPT_FLAGS" make %{?_smp_mflags} BOOT_CFLAGS="$OPT_FLAGS" profiledbootstrap
%else
GCJFLAGS="$OPT_FLAGS" make %{?_smp_mflags} BOOT_CFLAGS="$OPT_FLAGS" bootstrap-lean
%endif

mkdir -p libgfortranpreview
cd libgfortranpreview
CC="`pwd`/../gcc/xgcc -B `pwd`/../gcc/" \
GFORTRAN="`pwd`/../gcc/gfortran -B `pwd`/../gcc/" \
CFLAGS="$OPT_FLAGS" FCFLAGS="$OPT_FLAGS" ../../libgfortranpreview/configure \
	--prefix=%{_prefix} --enable-shared --enable-threads=posix \
	--host=%{_target_platform} --build=%{_target_platform} \
	--target=%{_target_platform} --disable-multilib
make %{?_smp_mflags}
cd ..

mkdir -p libgfortran0
cd libgfortran0
CC="`pwd`/../gcc/xgcc -B `pwd`/../gcc/" \
GFORTRAN="`pwd`/../gcc/gfortran -B `pwd`/../gcc/" \
CFLAGS="$OPT_FLAGS" FCFLAGS="$OPT_FLAGS" ../../libgfortran0/configure \
	--prefix=%{_prefix} --enable-shared --enable-threads=posix \
	--host=%{_target_platform} --build=%{_target_platform} \
	--target=%{_target_platform} --disable-multilib
make %{?_smp_mflags}
cd ..

# run the tests.
LC_ALL=C make %{?_smp_mflags} -k check RUNTESTFLAGS="ALT_CC_UNDER_TEST=gcc ALT_CXX_UNDER_TEST=g++" || :
echo ====================TESTING=========================
( ../contrib/test_summary || : ) 2>&1 | sed -n '/^cat.*EOF/,/^EOF/{/^cat.*EOF/d;/^EOF/d;/^LAST_UPDATED:/d;p;}'
echo ====================TESTING END=====================
mkdir testlogs-%{_target_platform}-%{version}-%{release}
for i in `find . -name \*.log | grep -F testsuite/ | grep -v 'config.log\|acats\|ada'`; do
  ln $i testlogs-%{_target_platform}-%{version}-%{release}/ || :
done
tar cf - testlogs-%{_target_platform}-%{version}-%{release} | bzip2 -9c \
  | uuencode testlogs-%{_target_platform}.tar.bz2 || :
rm -rf testlogs-%{_target_platform}-%{version}-%{release}

# Make protoize
make -C gcc CC="./xgcc -B ./ -O2" proto

# Make generated man pages even if Pod::Man is not new enough
perl -pi -e 's/head3/head2/' ../contrib/texi2pod.pl
for i in ../gcc/doc/*.texi; do
  cp -a $i $i.orig; sed 's/ftable/table/' $i.orig > $i
done
make -C gcc generated-manpages
for i in ../gcc/doc/*.texi; do mv -f $i.orig $i; done

# Copy various doc files here and there
cd ..
mkdir -p rpm.doc/gfortran
mkdir -p rpm.doc/boehm-gc rpm.doc/fastjar rpm.doc/libffi rpm.doc/libjava
mkdir -p rpm.doc/changelogs/{gcc/cp,gcc/java,gcc/ada,libstdc++-v3,libobjc,libmudflap,libgomp}

for i in {gcc,gcc/cp,gcc/java,gcc/ada,libstdc++-v3,libobjc,libmudflap,libgomp}/ChangeLog*; do
  cp -p $i rpm.doc/changelogs/$i
done

(cd gcc/fortran; for i in ChangeLog*; do
	cp -p $i ../../rpm.doc/gfortran/$i.f
done)
(cd libgfortran; for i in ChangeLog*; do
	cp -p $i ../rpm.doc/gfortran/$i.libgfortran
done)
(cd boehm-gc; for i in ChangeLog*; do
	cp -p $i ../rpm.doc/boehm-gc/$i.gc
done)
(cd fastjar; for i in ChangeLog* README*; do
	cp -p $i ../rpm.doc/fastjar/$i.fastjar
done)
(cd libffi; for i in ChangeLog* README* LICENSE; do
	cp -p $i ../rpm.doc/libffi/$i.libffi
done)
(cd libjava; for i in ChangeLog* README*; do
        cp -p $i ../rpm.doc/libjava/$i.libjava
done)
cp -p libjava/LIBGCJ_LICENSE rpm.doc/libjava/

rm -f rpm.doc/changelogs/gcc/ChangeLog.[1-9]
find rpm.doc -name \*ChangeLog\* | xargs bzip2 -9

%install
rm -fr $RPM_BUILD_ROOT

perl -pi -e \
  's~href="l(ibstdc|atest)~href="http://gcc.gnu.org/onlinedocs/libstdc++/l\1~' \
  libstdc++-v3/docs/html/documentation.html
ln -sf documentation.html libstdc++-v3/docs/html/index.html

cd obj-%{gcc_target_platform}

if [ ! -f /usr/lib/locale/de_DE/LC_CTYPE ]; then
  export LOCPATH=`pwd`/locale:/usr/lib/locale
fi

TARGET_PLATFORM=%{gcc_target_platform}

# There are some MP bugs in libstdc++ Makefiles
make -C %{gcc_target_platform}/libstdc++-v3

make DESTDIR=$RPM_BUILD_ROOT install
%if %{build_java}
make DESTDIR=$RPM_BUILD_ROOT -C %{gcc_target_platform}/libjava install-src.zip
%endif

cp -a libgfortranpreview/.libs/libgfortranpreview.so.0* $RPM_BUILD_ROOT%{_prefix}/%{_lib}/
cp -a libgfortran0/.libs/libgfortran.so.0* $RPM_BUILD_ROOT%{_prefix}/%{_lib}/

FULLPATH=$RPM_BUILD_ROOT%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}
FULLEPATH=$RPM_BUILD_ROOT%{_prefix}/libexec/gcc/%{gcc_target_platform}/%{gcc_version}

# fix some things
ln -sf gcc $RPM_BUILD_ROOT%{_prefix}/bin/cc
mkdir -p $RPM_BUILD_ROOT/lib
ln -sf ..%{_prefix}/bin/cpp $RPM_BUILD_ROOT/lib/cpp
ln -sf gfortran $RPM_BUILD_ROOT%{_prefix}/bin/f95
rm -f $RPM_BUILD_ROOT%{_infodir}/dir
gzip -9 $RPM_BUILD_ROOT%{_infodir}/*.info*

cxxconfig="`find %{gcc_target_platform}/libstdc++-v3/include -name c++config.h`"
for i in `find %{gcc_target_platform}/[36]*/libstdc++-v3/include -name c++config.h 2>/dev/null`; do
  if ! diff -up $cxxconfig $i; then
    cat > $RPM_BUILD_ROOT%{_prefix}/include/c++/%{gxx_primary_version}/%{gcc_target_platform}/bits/c++config.h <<EOF
#ifndef _CPP_CPPCONFIG_WRAPPER
#define _CPP_CPPCONFIG_WRAPPER 1
#include <bits/wordsize.h>
#if __WORDSIZE == 32
%ifarch %{multilib_64_archs}
`cat $(find %{gcc_target_platform}/32/libstdc++-v3/include -name c++config.h)`
%else
`cat $(find %{gcc_target_platform}/libstdc++-v3/include -name c++config.h)`
%endif
#else
%ifarch %{multilib_64_archs}
`cat $(find %{gcc_target_platform}/libstdc++-v3/include -name c++config.h)`
%else
`cat $(find %{gcc_target_platform}/64/libstdc++-v3/include -name c++config.h)`
%endif
#endif
#endif
EOF
    break
  fi
done

%ifarch sparc ppc
ln -f $RPM_BUILD_ROOT%{_prefix}/bin/%{gcc_target_platform}-gcc \
  $RPM_BUILD_ROOT%{_prefix}/bin/%{_target_platform}-gcc
%endif
%ifarch sparc64
ln -f $RPM_BUILD_ROOT%{_prefix}/bin/%{gcc_target_platform}-gcc \
  $RPM_BUILD_ROOT%{_prefix}/bin/sparc-%{_vendor}-%{_target_os}-gcc
%endif
%ifarch ppc64
ln -f $RPM_BUILD_ROOT%{_prefix}/bin/%{gcc_target_platform}-gcc \
  $RPM_BUILD_ROOT%{_prefix}/bin/ppc-%{_vendor}-%{_target_os}-gcc
%endif

%ifarch sparc ppc
FULLLPATH=$FULLPATH/lib32
%endif
%ifarch sparc64 ppc64
FULLLPATH=$FULLPATH/lib64
%endif
if [ -n "$FULLLPATH" ]; then
  mkdir -p $FULLLPATH
else
  FULLLPATH=$FULLPATH
fi

if [ "%{build_java}" -gt 0 ]; then
mv $RPM_BUILD_ROOT%{_prefix}/%{_lib}/libgcj.a $FULLLPATH/
mv $RPM_BUILD_ROOT%{_prefix}/%{_lib}/lib-gnu-java-awt-peer-gtk.a $FULLLPATH/
mv $RPM_BUILD_ROOT%{_prefix}/%{_lib}/libgij.a $FULLLPATH/
mv $RPM_BUILD_ROOT%{_prefix}/%{_lib}/libgcjawt.a $FULLLPATH/
mv $RPM_BUILD_ROOT%{_prefix}/lib/libgcj.spec $FULLPATH/
#mv $RPM_BUILD_ROOT%{_prefix}/include/gc*.h $FULLPATH/include/
#mv $RPM_BUILD_ROOT%{_prefix}/include/j*.h $FULLPATH/include/
#mv -f $RPM_BUILD_ROOT%{_prefix}/include/{java,javax,gnu,org} $FULLPATH/include/
#mv -f $RPM_BUILD_ROOT%{_prefix}/include/{java,javax,gnu} $FULLPATH/include/
mv -f $RPM_BUILD_ROOT/usr/include/c++/%{gxx_primary_version}/{java,javax,gnu,org} $FULLPATH/include/
mv -f $RPM_BUILD_ROOT/usr/include/c++/%{gxx_primary_version}/gcj/* $FULLPATH/include/gcj/
rmdir $RPM_BUILD_ROOT/usr/include/c++/%{gxx_primary_version}/gcj
fi

rm -rf $RPM_BUILD_ROOT/usr/include/c++/%{gxx_primary_version}/%{gcc_target_platform}
ln -sf `echo %{gcc_target_platform} | sed s/5E$//` \
  $RPM_BUILD_ROOT/usr/include/c++/%{gxx_primary_version}/%{gcc_target_platform}
%ifarch x86_64 s390x
ln -sf %{multilib_32_arch}-%{_vendor}-%{_target_os} \
  $RPM_BUILD_ROOT/usr/include/c++/%{gxx_primary_version}/%{multilib_32_arch}-%{_vendor}-%{_target_os}%{?_gnu}
%endif

mkdir -p $RPM_BUILD_ROOT/%{_lib}
mv -f $RPM_BUILD_ROOT%{_prefix}/%{_lib}/libgcc_s.so.1 $RPM_BUILD_ROOT/%{_lib}/libgcc_s-%{gcc_version}-%{DATE}.so.1
chmod 755 $RPM_BUILD_ROOT/%{_lib}/libgcc_s-%{gcc_version}-%{DATE}.so.1
ln -sf libgcc_s-%{gcc_version}-%{DATE}.so.1 $RPM_BUILD_ROOT/%{_lib}/libgcc_s.so.1
ln -sf /%{_lib}/libgcc_s.so.1 $FULLPATH/libgcc_s.so
%ifarch sparc ppc
ln -sf /lib64/libgcc_s.so.1 $FULLPATH/64/libgcc_s.so
%endif
%ifarch %{multilib_64_archs}
ln -sf /lib/libgcc_s.so.1 $FULLPATH/32/libgcc_s.so
%endif

mv -f $RPM_BUILD_ROOT%{_prefix}/%{_lib}/libgomp.spec $FULLPATH/
mv -f $RPM_BUILD_ROOT%{_prefix}/include/omp.h $FULLPATH/include/

%if %{build_java}
#mv -f $RPM_BUILD_ROOT%{_prefix}/%{_lib}/classpath/libgjsmalsa.so* \
#      $RPM_BUILD_ROOT%{_prefix}/%{_lib}/
mv -f $RPM_BUILD_ROOT%{_prefix}/lib/classpath/libgjsmalsa.so* \
      $RPM_BUILD_ROOT%{_prefix}/%{_lib}/

if [ "%{_lib}" != "lib" ]; then
  mkdir -p $RPM_BUILD_ROOT%{_prefix}/%{_lib}/pkgconfig
  sed '/^libdir/s/lib$/%{_lib}/' $RPM_BUILD_ROOT%{_prefix}/lib/pkgconfig/libgcj.pc \
    > $RPM_BUILD_ROOT%{_prefix}/%{_lib}/pkgconfig/libgcj.pc
fi
%endif

LIBSTDCXX_SO=`gcc -print-file-name=libstdc++_shared.so`
[ "$LIBSTDCXX_SO" = libstdc++_shared.so ] && LIBSTDCXX_SO=`gcc -print-file-name=libstdc++.so`
LIBSTDCXX_SUFFIX=6.`ls -l "$LIBSTDCXX_SO" | sed 's,^.*-> .*/libstdc++\.so\.6\.,,'`
pushd $FULLPATH
if [ "%{_lib}" = "lib" ]; then
ln -sf ../../../libstdc++.so.$LIBSTDCXX_SUFFIX libstdc++.so
ln -sf ../../../libgfortran.so.1.* libgfortran.so
ln -sf ../../../libgomp.so.1.* libgomp.so
ln -sf ../../../libmudflap.so.0.* libmudflap.so
ln -sf ../../../libmudflapth.so.0.* libmudflapth.so
%if %{build_java}
ln -sf ../../../libgcj.so.7.* libgcj.so
ln -sf ../../../lib-gnu-java-awt-peer-gtk.so.7.* lib-gnu-java-awt-peer-gtk.so
ln -sf ../../../libgjsmalsa.so.0.* libgjsmalsa.so
ln -sf ../../../libgij.so.7.* libgij.so
ln -sf ../../../libgcjawt.so.7.* libgcjawt.so
%endif
else
ln -sf ../../../../%{_lib}/libstdc++.so.$LIBSTDCXX_SUFFIX libstdc++.so
ln -sf ../../../../%{_lib}/libgfortran.so.1.* libgfortran.so
ln -sf ../../../../%{_lib}/libgomp.so.1.* libgomp.so
ln -sf ../../../../%{_lib}/libmudflap.so.0.* libmudflap.so
ln -sf ../../../../%{_lib}/libmudflapth.so.0.* libmudflapth.so
%if %{build_java}
ln -sf ../../../../%{_lib}/libgcj.so.7.* libgcj.so
ln -sf ../../../../%{_lib}/lib-gnu-java-awt-peer-gtk.so.7.* lib-gnu-java-awt-peer-gtk.so
ln -sf ../../../../%{_lib}/libgjsmalsa.so.0.* libgjsmalsa.so
ln -sf ../../../../%{_lib}/libgij.so.7.* libgij.so
ln -sf ../../../../%{_lib}/libgcjawt.so.7.* libgcjawt.so
%endif
fi
mv -f $RPM_BUILD_ROOT%{_prefix}/%{_lib}/libstdc++.*a $FULLLPATH/
mv -f $RPM_BUILD_ROOT%{_prefix}/%{_lib}/libsupc++.*a .
mv -f $RPM_BUILD_ROOT%{_prefix}/%{_lib}/libgfortran.*a .
mv -f $RPM_BUILD_ROOT%{_prefix}/%{_lib}/libgfortranbegin.*a .
mv -f $RPM_BUILD_ROOT%{_prefix}/%{_lib}/libgomp.*a .
mv -f $RPM_BUILD_ROOT%{_prefix}/%{_lib}/libmudflap{,th}.*a $FULLLPATH/
mv -f $RPM_BUILD_ROOT%{_prefix}/include/mf-runtime.h include/

%ifarch sparc ppc
ln -sf ../`echo ../../../../lib/libstdc++.so.$LIBSTDCXX_SUFFIX | sed s~/lib/~/lib64/~` 64/libstdc++.so
ln -sf ../`echo ../../../../lib/libgfortran.so.1.* | sed s~/lib/~/lib64/~` 64/libgfortran.so
ln -sf ../`echo ../../../../lib/libgomp.so.1.* | sed s~/lib/~/lib64/~` 64/libgomp.so
rm -f libmudflap.so libmudflapth.so
echo 'INPUT ( %{_prefix}/lib/'`echo ../../../../lib/libmudflap.so.0.* | sed 's,^.*libm,libm,'`' )' > libmudflap.so
echo 'INPUT ( %{_prefix}/lib/'`echo ../../../../lib/libmudflapth.so.0.* | sed 's,^.*libm,libm,'`' )' > libmudflapth.so
echo 'INPUT ( %{_prefix}/lib64/'`echo ../../../../lib/libmudflap.so.0.* | sed 's,^.*libm,libm,'`' )' > 64/libmudflap.so
echo 'INPUT ( %{_prefix}/lib64/'`echo ../../../../lib/libmudflapth.so.0.* | sed 's,^.*libm,libm,'`' )' > 64/libmudflapth.so
if [ "%{build_java}" -gt 0 ]; then
ln -sf ../`echo ../../../../lib/libgcj.so.7.* | sed s~/lib/~/lib64/~` 64/libgcj.so
ln -sf ../`echo ../../../../lib/lib-gnu-java-awt-peer-gtk.so.7.* | sed s~/lib/~/lib64/~` 64/lib-gnu-java-awt-peer-gtk.so
ln -sf ../`echo ../../../../lib/libgjsmalsa.so.0.* | sed s~/lib/~/lib64/~` 64/libgjsmalsa.so
ln -sf ../`echo ../../../../lib/libgij.so.7.* | sed s~/lib/~/lib64/~` 64/libgij.so
ln -sf ../`echo ../../../../lib/libgcjawt.so.7.* | sed s~/lib/~/lib64/~` 64/libgcjawt.so
fi
mv -f $RPM_BUILD_ROOT%{_prefix}/lib64/libsupc++.*a 64/
mv -f $RPM_BUILD_ROOT%{_prefix}/lib64/libgfortran.*a 64/
mv -f $RPM_BUILD_ROOT%{_prefix}/lib64/libgfortranbegin.*a 64/
mv -f $RPM_BUILD_ROOT%{_prefix}/lib64/libgomp.*a 64/
#ln -sf lib32/libstdc++.a libstdc++.a
#ln -sf ../lib64/libstdc++.a 64/libstdc++.a
ln -sf ../../%{gcc_primary_target_platform}/%{gxx_primary_version}/lib32/libstdc++.a libstdc++.a
ln -sf ../../../%{gcc_primary_target_platform}/%{gxx_primary_version}/lib64/libstdc++.a 64/libstdc++.a
ln -sf lib32/libmudflap.a libmudflap.a
ln -sf ../lib64/libmudflap.a 64/libmudflap.a
ln -sf lib32/libmudflapth.a libmudflapth.a
ln -sf ../lib64/libmudflapth.a 64/libmudflapth.a
if [ "%{build_java}" -gt 0 ]; then
ln -sf lib32/libgcj.a libgcj.a
ln -sf ../lib64/libgcj.a 64/libgcj.a
ln -sf lib32/lib-gnu-java-awt-peer-gtk.a lib-gnu-java-awt-peer-gtk.a
ln -sf ../lib64/lib-gnu-java-awt-peer-gtk.a 64/lib-gnu-java-awt-peer-gtk.a
ln -sf lib32/libgij.a libgij.a
ln -sf ../lib64/libgij.a 64/libgij.a
ln -sf lib32/libgcjawt.a libgcjawt.a
ln -sf ../lib64/libgcjawt.a 64/libgcjawt.a
fi
%endif
%ifarch %{multilib_64_archs}
mkdir -p 32
ln -sf ../`echo ../../../../lib64/libstdc++.so.$LIBSTDCXX_SUFFIX | sed s~/../lib64/~/~` 32/libstdc++.so
ln -sf ../`echo ../../../../lib64/libgfortran.so.1.* | sed s~/../lib64/~/~` 32/libgfortran.so
ln -sf ../`echo ../../../../lib64/libgomp.so.1.* | sed s~/../lib64/~/~` 32/libgomp.so
rm -f libmudflap.so libmudflapth.so
echo 'INPUT ( %{_prefix}/lib64/'`echo ../../../../lib64/libmudflap.so.0.* | sed 's,^.*libm,libm,'`' )' > libmudflap.so
echo 'INPUT ( %{_prefix}/lib64/'`echo ../../../../lib64/libmudflapth.so.0.* | sed 's,^.*libm,libm,'`' )' > libmudflapth.so
echo 'INPUT ( %{_prefix}/lib/'`echo ../../../../lib64/libmudflap.so.0.* | sed 's,^.*libm,libm,'`' )' > 32/libmudflap.so
echo 'INPUT ( %{_prefix}/lib/'`echo ../../../../lib64/libmudflapth.so.0.* | sed 's,^.*libm,libm,'`' )' > 32/libmudflapth.so
if [ "%{build_java}" -gt 0 ]; then
ln -sf ../`echo ../../../../lib64/libgcj.so.7.* | sed s~/../lib64/~/~` 32/libgcj.so
ln -sf ../`echo ../../../../lib64/lib-gnu-java-awt-peer-gtk.so.7.* | sed s~/../lib64/~/~` 32/lib-gnu-java-awt-peer-gtk.so
ln -sf ../`echo ../../../../lib64/libgjsmalsa.so.0.* | sed s~/../lib64/~/~` 32/libgjsmalsa.so
ln -sf ../`echo ../../../../lib64/libgij.so.7.* | sed s~/../lib64/~/~` 32/libgij.so
ln -sf ../`echo ../../../../lib64/libgcjawt.so.7.* | sed s~/../lib64/~/~` 32/libgcjawt.so
fi
mv -f $RPM_BUILD_ROOT%{_prefix}/lib/libsupc++.*a 32/
mv -f $RPM_BUILD_ROOT%{_prefix}/lib/libgfortran.*a 32/
mv -f $RPM_BUILD_ROOT%{_prefix}/lib/libgfortranbegin.*a 32/
mv -f $RPM_BUILD_ROOT%{_prefix}/lib/libgomp.*a 32/
%endif
%ifarch sparc64 ppc64
#ln -sf ../lib32/libstdc++.a 32/libstdc++.a
#ln -sf lib64/libstdc++.a libstdc++.a
ln -sf ../../../%{gcc_primary_target_platform}/%{gxx_primary_version}/lib32/libstdc++.a 32/libstdc++.a
ln -sf ../../%{gcc_primary_target_platform}/%{gxx_primary_version}/lib64/libstdc++.a libstdc++.a
ln -sf ../lib32/libmudflap.a 32/libmudflap.a
ln -sf lib64/libmudflap.a libmudflap.a
ln -sf ../lib32/libmudflapth.a 32/libmudflapth.a
ln -sf lib64/libmudflapth.a libmudflapth.a
if [ "%{build_java}" -gt 0 ]; then
ln -sf ../lib32/libgcj.a 32/libgcj.a
ln -sf lib64/libgcj.a libgcj.a
ln -sf ../lib32/lib-gnu-java-awt-peer-gtk.a 32/lib-gnu-java-awt-peer-gtk.a
ln -sf lib64/lib-gnu-java-awt-peer-gtk.a lib-gnu-java-awt-peer-gtk.a
ln -sf ../lib32/libgij.a 32/libgij.a
ln -sf lib64/libgij.a libgij.a
ln -sf ../lib32/libgcjawt.a 32/libgcjawt.a
ln -sf lib64/libgcjawt.a libgcjawt.a
fi
%else
%ifarch %{multilib_64_archs}
#ln -sf ../../../%{multilib_32_arch}-%{_vendor}-%{_target_os}/%{gcc_version}/libstdc++.a 32/libstdc++.a
ln -sf ../../../%{multilib_32_arch}-%{_vendor}-%{_target_os}/%{gxx_primary_version}/libstdc++.a 32/libstdc++.a
ln -sf ../../../%{multilib_32_arch}-%{_vendor}-%{_target_os}/%{version}/libmudflap.a 32/libmudflap.a
ln -sf ../../../%{multilib_32_arch}-%{_vendor}-%{_target_os}/%{version}/libmudflapth.a 32/libmudflapth.a
if [ "%{build_java}" -gt 0 ]; then
ln -sf ../../../%{multilib_32_arch}-%{_vendor}-%{_target_os}/%{gcc_version}/libgcj.a 32/libgcj.a
ln -sf ../../../%{multilib_32_arch}-%{_vendor}-%{_target_os}/%{gcc_version}/lib-gnu-java-awt-peer-gtk.a 32/lib-gnu-java-awt-peer-gtk.a
ln -sf ../../../%{multilib_32_arch}-%{_vendor}-%{_target_os}/%{gcc_version}/libgij.a 32/libgij.a
ln -sf ../../../%{multilib_32_arch}-%{_vendor}-%{_target_os}/%{gcc_version}/libgcjawt.a 32/libgcjawt.a
fi
%endif
%endif
%ifnarch sparc ppc sparc64 ppc64
ln -sf ../../%{gcc_primary_target_platform}/%{gxx_primary_version}/libstdc++.a libstdc++.a
%endif
ln -sf ../../%{gcc_primary_target_platform}/%{gxx_primary_version}/libstdc++.so libstdc++.so
ln -sf ../../%{gcc_primary_target_platform}/%{gxx_primary_version}/libstdc++_shared.so libstdc++_shared.so
ln -sf ../../%{gcc_primary_target_platform}/%{gxx_primary_version}/libstdc++_nonshared.a libstdc++_nonshared.a
%ifarch sparc ppc
ln -sf ../../../%{gcc_primary_target_platform}/%{gxx_primary_version}/64/libstdc++.so 64/libstdc++.so
ln -sf ../../../%{gcc_primary_target_platform}/%{gxx_primary_version}/64/libstdc++_shared.so 64/libstdc++_shared.so
ln -sf ../../../%{gcc_primary_target_platform}/%{gxx_primary_version}/64/libstdc++_nonshared.a 64/libstdc++_nonshared.a
%else
%ifarch %{multilib_64_archs}
ln -sf ../../../%{gcc_primary_target_platform}/%{gxx_primary_version}/32/libstdc++.so 32/libstdc++.so
ln -sf ../../../%{gcc_primary_target_platform}/%{gxx_primary_version}/32/libstdc++_shared.so 32/libstdc++_shared.so
ln -sf ../../../%{gcc_primary_target_platform}/%{gxx_primary_version}/32/libstdc++_nonshared.a 32/libstdc++_nonshared.a
%endif
%endif

# Strip debug info from Fortran/ObjC/Java static libraries
strip -g `find . \( -name libgfortran.a -o -name libobjc.a -o -name libgcj.a -o -name libgomp.a \
		    -o -name lib-gnu-java-awt-peer-gtk.a -o -name libgij.a \
		    -o -name libgcjawt.a -o -name libmudflap.a -o -name libmudflapth.a \
		    -o -name libgcc.a -o -name libgcov.a \) -a -type f`
popd
chmod 755 $RPM_BUILD_ROOT%{_prefix}/%{_lib}/libgfortran{,preview}.so.[01].*
chmod 755 $RPM_BUILD_ROOT%{_prefix}/%{_lib}/libmudflap{,th}.so.0.*

for h in `find $FULLPATH/include -name \*.h`; do
  if grep -q 'It has been auto-edited by fixincludes from' $h; then
    rh=`grep -A2 'It has been auto-edited by fixincludes from' $h | tail -1 | sed 's|^.*"\(.*\)".*$|\1|'`
    diff -up $rh $h || :
    rm -f $h
  fi
done

cat > $RPM_BUILD_ROOT%{_prefix}/bin/c89 <<"EOF"
#!/bin/sh
fl="-std=c89"
for opt; do
  case "$opt" in
    -ansi|-std=c89|-std=iso9899:1990) fl="";;
    -std=*) echo "`basename $0` called with non ANSI/ISO C option $opt" >&2
	    exit 1;;
  esac
done
exec gcc $fl ${1+"$@"}
EOF
cat > $RPM_BUILD_ROOT%{_prefix}/bin/c99 <<"EOF"
#!/bin/sh
fl="-std=c99"
for opt; do
  case "$opt" in
    -std=c99|-std=iso9899:1999) fl="";;
    -std=*) echo "`basename $0` called with non ISO C99 option $opt" >&2
	    exit 1;;
  esac
done
exec gcc $fl ${1+"$@"}
EOF
chmod 755 $RPM_BUILD_ROOT%{_prefix}/bin/c?9

mkdir -p $RPM_BUILD_ROOT%{_prefix}/sbin
gcc -static -Os %{SOURCE1} -o $RPM_BUILD_ROOT%{_prefix}/sbin/libgcc_post_upgrade
strip $RPM_BUILD_ROOT%{_prefix}/sbin/libgcc_post_upgrade

cd ..

for i in $RPM_BUILD_ROOT%{_prefix}/bin/{*gcc,*++,gcov}; do
  mv -f $i ${i}4
done
%if %{build_java}
for i in $RPM_BUILD_ROOT%{_prefix}/bin/{gcj,gcjh,gjnih,jcf-dump,jv*,gij,*jar,*rmi*,gcj-dbtool}; do
  mv -f $i ${i}4
done
%endif

# Remove binaries we will not be including, so that they don't end up in
# gcc4-debuginfo
rm -f $RPM_BUILD_ROOT%{_prefix}/bin/{c++4,c89,c99,cpp,gccbug,*-linux-gcc-4*,*-linux-gcj,*-linux-gcjh,protoize,unprotoize}
rm -f $RPM_BUILD_ROOT/%{_lib}/libgcc_s-4*
rm -f $RPM_BUILD_ROOT%{_prefix}/%{_lib}/{libffi*,libiberty.a,libstdc++*}
rm -f $FULLEPATH/{cc1obj,install-tools/{mkheaders,fixincl}}
rm -f $RPM_BUILD_ROOT%{_prefix}/sbin/libgcc_post_upgrade
rm -f $RPM_BUILD_ROOT%{_prefix}/lib/{32,64}/libiberty.a
rm -f $RPM_BUILD_ROOT%{_prefix}/%{_lib}/libssp*
%ifarch %{multilib_64_archs}
rm -f $RPM_BUILD_ROOT%{_prefix}/lib/{libgcc_s*,libgij*,libgcjawt*,lib-gnu*,libffi*,libiberty.a,libstdc++*,libgfortran*,libmudflap*}
%endif
%ifarch sparc ppc
rm -rf $RPM_BUILD_ROOT%{_prefix}/lib/64
rm -f $RPM_BUILD_ROOT%{_prefix}/lib64/{libgcc_s*,libgij*,libgcjawt*,lib-gnu*,libffi*,libiberty.a,libstdc++*,libgfortran*,libmudflap*}
%endif

# gcj -static doesn't work properly anyway, unless using --whole-archive
# and saving 35MB is not bad.
find $RPM_BUILD_ROOT -name libgcj.a -o -name lib-gnu-java-awt-peer-gtk.a \
		     -o -name libgij.a -o -name libgcjawt.a | xargs rm -f
sed -i -e 's/lib: /&%%{static:%%eJava programs cannot be linked statically}/' \
  $FULLPATH/libgcj.spec

%if %{build_java}
mkdir -p $RPM_BUILD_ROOT%{_prefix}/share/java/gcj-endorsed \
	 $RPM_BUILD_ROOT%{_prefix}/%{_lib}/gcj4-%{version}/classmap.db.d
chmod 755 $RPM_BUILD_ROOT%{_prefix}/share/java/gcj-endorsed \
	  $RPM_BUILD_ROOT%{_prefix}/%{_lib}/gcj4-%{version} \
	  $RPM_BUILD_ROOT%{_prefix}/%{_lib}/gcj4-%{version}/classmap.db.d
touch $RPM_BUILD_ROOT%{_prefix}/%{_lib}/gcj4-%{version}/classmap.db
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%post gfortran
/sbin/install-info \
  --info-dir=%{_infodir} %{_infodir}/gfortran.info.gz

%preun gfortran
if [ $1 = 0 ]; then
  /sbin/install-info --delete \
    --info-dir=%{_infodir} %{_infodir}/gfortran.info.gz
fi

%post -n libgfortran -p /sbin/ldconfig

%postun -n libgfortran -p /sbin/ldconfig

%post -n libgomp -p /sbin/ldconfig

%postun -n libgomp -p /sbin/ldconfig

%post -n libmudflap -p /sbin/ldconfig

%postun -n libmudflap -p /sbin/ldconfig

%post -n libgcj4 -p /sbin/ldconfig

%postun -n libgcj4 -p /sbin/ldconfig

%files
%defattr(-,root,root)
%{_prefix}/bin/gcc4
%{_prefix}/bin/gcov4
%ifarch sparc ppc
%{_prefix}/bin/%{_target_platform}-gcc4
%endif
%ifarch sparc64
%{_prefix}/bin/sparc-%{_vendor}-%{_target_os}-gcc4
%endif
%ifarch ppc64
%{_prefix}/bin/ppc-%{_vendor}-%{_target_os}-gcc4
%endif
%{_prefix}/bin/%{gcc_target_platform}-gcc4
%dir %{_prefix}/lib/gcc
%dir %{_prefix}/lib/gcc/%{gcc_target_platform}
%dir %{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}
%dir %{_prefix}/libexec/gcc
%dir %{_prefix}/libexec/gcc/%{gcc_target_platform}
%dir %{_prefix}/libexec/gcc/%{gcc_target_platform}/%{gcc_version}
%dir %{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/stddef.h
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/stdarg.h
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/varargs.h
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/float.h
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/limits.h
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/stdbool.h
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/iso646.h
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/syslimits.h
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/unwind.h
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/omp.h
%ifarch %{ix86} x86_64
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/mmintrin.h
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/xmmintrin.h
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/emmintrin.h
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/pmmintrin.h
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/tmmintrin.h
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/ammintrin.h
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/bmmintrin.h
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/mmintrin-common.h
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/mm_malloc.h
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/mm3dnow.h
%endif
%ifarch ia64
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/ia64intrin.h
%endif
%ifarch ppc ppc64
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/ppc-asm.h
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/altivec.h
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/spe.h
%endif
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/README
%{_prefix}/libexec/gcc/%{gcc_target_platform}/%{gcc_version}/collect2
%{_prefix}/libexec/gcc/%{gcc_target_platform}/%{gcc_version}/cc1
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/crt*.o
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/libgcc.a
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/libgcov.a
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/libgcc_eh.a
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/libgcc_s.so
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/libgomp.spec
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/libgomp.a
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/libgomp.so
%ifarch sparc ppc
%dir %{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/64
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/64/crt*.o
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/64/libgcc.a
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/64/libgcov.a
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/64/libgcc_eh.a
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/64/libgcc_s.so
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/64/libgomp.a
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/64/libgomp.so
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/64/libmudflap.a
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/64/libmudflapth.a
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/64/libmudflap.so
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/64/libmudflapth.so
%endif
%ifarch %{multilib_64_archs}
%dir %{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/32
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/32/crt*.o
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/32/libgcc.a
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/32/libgcov.a
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/32/libgcc_eh.a
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/32/libgcc_s.so
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/32/libgomp.a
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/32/libgomp.so
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/32/libmudflap.a
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/32/libmudflapth.a
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/32/libmudflap.so
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/32/libmudflapth.so
%endif
%ifarch sparc sparc64 ppc ppc64
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/libmudflap.a
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/libmudflapth.a
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/libmudflap.so
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/libmudflapth.so
%endif
#%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/specs
%doc gcc/README* rpm.doc/changelogs/gcc/ChangeLog* gcc/COPYING*

%files c++
%defattr(-,root,root)
%{_prefix}/bin/%{gcc_target_platform}-*++4
%{_prefix}/bin/g++4
%dir %{_prefix}/lib/gcc
%dir %{_prefix}/lib/gcc/%{gcc_target_platform}
%dir %{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}
%dir %{_prefix}/libexec/gcc
%dir %{_prefix}/libexec/gcc/%{gcc_target_platform}
%dir %{_prefix}/libexec/gcc/%{gcc_target_platform}/%{gcc_version}
%{_prefix}/libexec/gcc/%{gcc_target_platform}/%{gcc_version}/cc1plus
%ifarch sparc ppc
%dir %{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/64
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/64/libstdc++.so
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/64/libstdc++_shared.so
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/64/libstdc++_nonshared.a
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/64/libstdc++.a
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/64/libsupc++.a
%endif
%ifarch %{multilib_64_archs}
%dir %{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/32
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/32/libstdc++.so
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/32/libstdc++_shared.so
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/32/libstdc++_nonshared.a
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/32/libstdc++.a
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/32/libsupc++.a
%endif
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/libstdc++.so
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/libstdc++_shared.so
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/libstdc++_nonshared.a
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/libsupc++.a
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/libstdc++.a
%dir %{_prefix}/include/c++
%dir %{_prefix}/include/c++/%{gxx_primary_version}
%{_prefix}/include/c++/%{gxx_primary_version}/%{gcc_target_platform}
%ifarch x86_64 s390x
%{_prefix}/include/c++/%{gxx_primary_version}/%{multilib_32_arch}-%{_vendor}-%{_target_os}%{?_gnu}
%endif
%doc rpm.doc/changelogs/gcc/cp/ChangeLog*

%if %{build_java}
%files java
%defattr(-,root,root)
%{_prefix}/bin/gcj4
%{_prefix}/bin/gcjh4
%{_prefix}/bin/gjnih4
%{_prefix}/bin/jcf-dump4
%{_prefix}/bin/jv-scan4
%dir %{_prefix}/lib/gcc
%dir %{_prefix}/lib/gcc/%{gcc_target_platform}
%dir %{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}
%dir %{_prefix}/libexec/gcc
%dir %{_prefix}/libexec/gcc/%{gcc_target_platform}
%dir %{_prefix}/libexec/gcc/%{gcc_target_platform}/%{gcc_version}
%{_prefix}/libexec/gcc/%{gcc_target_platform}/%{gcc_version}/jc1
%{_prefix}/libexec/gcc/%{gcc_target_platform}/%{gcc_version}/jvgenmain
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/libgcj.so
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/lib-gnu-java-awt-peer-gtk.so
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/libgij.so
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/libgcjawt.so
%ifarch sparc ppc
%dir %{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/64
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/64/libgcj.so
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/64/lib-gnu-java-awt-peer-gtk.so
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/64/libgij.so
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/64/libgcjawt.so
%endif
%ifarch %{multilib_64_archs}
%dir %{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/32
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/32/libgcj.so
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/32/lib-gnu-java-awt-peer-gtk.so
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/32/libgij.so
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/32/libgcjawt.so
%endif
%doc rpm.doc/changelogs/gcc/java/ChangeLog*

%files -n libgcj4
%defattr(-,root,root)
%{_prefix}/bin/jv-convert4
%{_prefix}/bin/gij4
%{_prefix}/bin/fastjar4
%{_prefix}/bin/grepjar4
%{_prefix}/bin/grmic4
%{_prefix}/bin/grmiregistry4
%{_prefix}/bin/gcj-dbtool4
%{_prefix}/%{_lib}/libgcj.so.*
%{_prefix}/%{_lib}/lib-gnu-java-awt-peer-gtk.so.*
%{_prefix}/%{_lib}/libgjsmalsa.so.*
%{_prefix}/%{_lib}/libgij.so.*
%{_prefix}/%{_lib}/libgcjawt.so.*
%dir %{_prefix}/share/java
%{_prefix}/share/java/[^s]*
%dir %{_prefix}/lib/security
%{_prefix}/lib/security/classpath.security
%{_prefix}/lib/security/libgcj.security
%{_prefix}/lib/logging.properties
%dir %{_prefix}/%{_lib}/gcj4-%{version}
%dir %{_prefix}/%{_lib}/gcj4-%{version}/classmap.db.d
%attr(0644,root,root) %verify(not md5 size mtime) %ghost
%config(missingok,noreplace) %{_prefix}/%{_lib}/gcj4-%{version}/classmap.db

%files -n libgcj4-devel
%defattr(-,root,root)
%{_prefix}/bin/addr2name.awk
%dir %{_prefix}/lib/gcc
%dir %{_prefix}/lib/gcc/%{gcc_target_platform}
%dir %{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}
%dir %{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/libgcj.spec
#%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/gc*.h
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/j*.h
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/java
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/javax
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/gnu
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/gcj
#%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/org
#%{_prefix}/%{_lib}/pkgconfig/libgcj.pc
%doc rpm.doc/boehm-gc/* rpm.doc/fastjar/* rpm.doc/libffi/*
%doc rpm.doc/libjava/*

%files -n libgcj4-src
%defattr(-,root,root)
%dir %{_prefix}/share/java
%{_prefix}/share/java/src*.zip
%endif

%files gfortran
%defattr(-,root,root)
%{_prefix}/bin/gfortran
%{_mandir}/man1/gfortran.1*
%{_infodir}/gfortran*
%dir %{_prefix}/lib/gcc
%dir %{_prefix}/lib/gcc/%{gcc_target_platform}
%dir %{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}
%dir %{_prefix}/libexec/gcc
%dir %{_prefix}/libexec/gcc/%{gcc_target_platform}
%dir %{_prefix}/libexec/gcc/%{gcc_target_platform}/%{gcc_version}
%dir %{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/finclude
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/finclude/omp_lib.h
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/finclude/omp_lib.f90
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/finclude/omp_lib.mod
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/finclude/omp_lib_kinds.mod
%{_prefix}/libexec/gcc/%{gcc_target_platform}/%{gcc_version}/f951
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/libgfortranbegin.a
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/libgfortran.a
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/libgfortran.so
%ifarch sparc ppc
%dir %{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/64
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/64/libgfortranbegin.a
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/64/libgfortran.a
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/64/libgfortran.so
%endif
%ifarch %{multilib_64_archs}
%dir %{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/32
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/32/libgfortranbegin.a
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/32/libgfortran.a
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/32/libgfortran.so
%endif
%doc rpm.doc/gfortran/*

%files -n libgfortran
%defattr(-,root,root)
%{_prefix}/%{_lib}/libgfortran.so.1*
%{_prefix}/%{_lib}/libgfortran.so.0*
%{_prefix}/%{_lib}/libgfortranpreview.so.0*

%files -n libgomp
%defattr(-,root,root)
%{_prefix}/%{_lib}/libgomp.so.1*
%doc rpm.doc/changelogs/libgomp/ChangeLog*

%files -n libmudflap
%defattr(-,root,root)
%{_prefix}/%{_lib}/libmudflap.so.0*
%{_prefix}/%{_lib}/libmudflapth.so.0*

%files -n libmudflap-devel
%defattr(-,root,root)
%dir %{_prefix}/lib/gcc
%dir %{_prefix}/lib/gcc/%{gcc_target_platform}
%dir %{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}
%dir %{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/mf-runtime.h
%ifarch sparc ppc
%dir %{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/lib32
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/lib32/libmudflap.a
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/lib32/libmudflapth.a
%endif
%ifarch sparc64 ppc64
%dir %{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/lib64
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/lib64/libmudflap.a
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/lib64/libmudflapth.a
%endif
%ifnarch sparc sparc64 ppc ppc64
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/libmudflap.a
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/libmudflapth.a
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/libmudflap.so
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/libmudflapth.so
%endif
%doc rpm.doc/changelogs/libmudflap/ChangeLog*

%changelog
* Tue Apr 15 2008 Jakub Jelinek <jakub@redhat.com> 4.1.2-42.EL4
- update from gcc-4_1-branch (-r126008:130387)
  - PRs middle-end/34030, rtl-optimization/28062, rtl-optimization/33822,
	bootstrap/33418, c++/31941, c++/32113, java/31842, target/33256,
	tree-optimization/33142, c++/32112, c++/17763, rtl-optimization/32450,
	target/31331, target/32641, target/32660, tree-optimization/32681,
	boehm-gc/21940, boehm-gc/21942, target/28307, target/32506,
	tree-optimization/31966, tree-optimization/32533
  - fix if-conversion to avoid introducing races into threaded code
    (Ian Lance Taylor, #391731)
- move the gcc4 lib/libexec dirs to /usr/lib{,exec}/*-linux5E/ from
  /usr/lib{,exec}/*-linux/ and also move /usr/lib*/gcj-* to /usr/lib*/gcj4-*
  to avoid upgrade problems to RHEL5.1 and higher (#434847)
- fix PCH failure if a precompiled header is included more than
  once (#251682, PR pch/13675)
- allow non-aggregate extern "Java" types in C++ placement new
  (PR c++/34829, Tom Tromey)
- make sure no errors are reported during tentative parsing of
  pseudo-destructors (PR c++/35138)
- fix i386 <= 0xNNffffffffLL comparison optimization (Michael Matz,
  PR target/35264)
- generate DW_TAG_class_type for C++ and Java classes in DWARF3
  debuginfo (#371831, PR debug/7081)
- don't unnecessarily create a stack frame in leaf functions e.g. on ppc with
  -fpic or -maltivec (Nathan Sidwell, Daniel Jacobowitz, #369541,
  PRs target/28966, target/29248)
- compile libstdc++-4*.s390.rpm DSO with -march=z900, as RHEL5 only supports
  those CPUs.  libstdc++-devel*.s390.rpm should still work even for older
  CPUs (#298801)
- add SSE5 support (Michael Meissner, Dwarakanath Rajagopal, Tony Linthicum,
  Uros Bizjak, #252998)
- java_mark_cni_decl_local fix (Andrew Haley, #414411, PR java/27643)
- i386 <= 0xNNffffffffLL comparison optimization (PR target/29978)
- fix Fortran alternate returns with dummy procedure (Paul Thomas, #399531,
  PR fortran/31483)
- OpenMP fixes (PR c++/33890, c/34506, c++/34513)
- don't hold a global guard mutex across whole local static initialization
  (Doug Kwan, #426846)
- fix OpenMP handling of global vars privatized in orphaned constructs
  with #pragma omp parallel inside them
- -frepo fixes (#411741, PRs c++/34178, c++/34340)
- fix dynamic_cast<C &> in templates (PR c++/34364)
- fix error diagnostics involving ABS_EXPR (PR c++/34394)
- two ctor preevaluation fixes (Olivier Hainque,
  Eric Botcazou, #407281)
- consider static data members and static member functions in anon ns
  classes to be external for C++ linkage type handling (PR c++/34213)
- handle OBJ_TYPE_REF in C++ diagnostics (PR c++/34275)
- backport a bunch of bugfixes from GCC trunk
  - PRs c++/29225, c++/30293, c++/30294, c++/30988, c++/32241,
	c++/32384, c++/33501, c++/33516, c++/33616, c++/33836,
	c++/33842, c++/33844, c++/33962, c++/34089,
	c/34146, debug/33537, middle-end/23848, middle-end/34070,
	testsuite/33978, tree-optimization/33723
- fix abs optimization (Richard Guenther, #394271, PR middle-end/34130)
- fortran lbound/ubound fix (Paul Thomas, #391151, PR fortran/29712)
- generate proper fortran debuginfo for assumed-size, assumed-shape
  and deferred arrays (#364001)
- fix ppc64 unwinding of cr2 register if vdso=0
- only allow __label__ at the start of a block (PR c++/32121)
- disable -fipa-type-escape by default (PR tree-optimization/33136)
- VLA handling fix (PR c/33238, PR c/27301)
- disable TER of pure and const function calls except for __builtin_expect
  (PR tree-optimization/33619)
- fix parsing of C++ function-like cast in template argument where cast's
  argument uses greater-than operator (PR c++/33744)
- ignore always_inline attribute on redefined extern inline
  functions (Jan Hubicka, #329671, PR tree-optimization/33763)
- add support for Fortran int conversion intrinsics (Francois-Xavier
  Coudert, #317051)
- don't drop DECL_BUILT_IN_CLASS when defining a builtin function
- print virtual inline backtrace in some diagnostic messages to help
  locate bugs reported with -D_FORTIFY_SOURCE{,=2}
- add support for artificial, error and warning attributes
- fix ICE with set_rhs allowing non-gimple (Roger Sayle, #247407,
  PR tree-optimization/32694)
- fix ICE on Fortran interface-body declaring current subroutine name
  (Paul Thomas, #300851, PR fortran/20880)
- don't ignore throw specification of function types in type hashing
  (PR c++/33506)
- fix ICE on __builtin_mem*_chk if it couldn't be folded until
  expand time and at that point it can avoid a call (PR middle-end/33423)
- handle the upcoming POSIX 'm' *scanf allocation modifier in
  GCC format checking, fix up some details about %as/%aS/%a[
- backport __builtin_va_arg_pack () and __builtin_va_arg_pack_len () support
- fix Fortran error recovery with DATA (Jerry DeLisle, #281331,
  PR fortran/27954)
- make sure __builtin_{,v}{,f}{print,scan}f, __builtin_{,f}printf_unlocked
  and __builtin___{,v}{,f}printf_chk can throw
- handle __*_chk builtins without __builtin_ in the name as anticipated in
  C++
- fix libmudflap-devel multilib conflict on ppc/ppc64 and sparc/sparc64
  (#270281)
- backport __attribute__((__gnu_inline__)) support for C++
- fix ppc/ppc64 __sync_* builtins with aligned 8 or 16-bit values
- don't set executable flag on .note.GNU-stack on ppc64/ia64 even
  when trampolines are used - trampolines on those architectures
  don't need executable stack
- fix ppc32 libgcc.a(tramp.o), so that binaries using trampolines
  aren't forced to use bss PLT
- fix a fortran charlen sharing bug (#253102)
- fix ICE with X|~X or X^~X with vectors (PR middle-end/32912)
- nuke bits/stdc++.gch directories from libstdc++-devel (#253304)
- fix fortran Tx format handling (Jerry DeLisle, #252152,
  PR libgfortran/32678)
- don't NRV optimize fields inside anonymous unions (PR c++/32992)
- fortran debuginfo improvements for constant bound arrays (#248541,
  PR fortran/22244)

* Tue Jul 31 2007 Jakub Jelinek  <jakub@redhat.com> 4.1.2-14.EL4
- update from redhat/fc5-4_1-branch (#240142)
  - GCC 4.1.2 release
  - PRs inline-asm/32109, rtl-optimization/28011, target/32389,
	libfortran/31409, libfortran/31880, libfortran/31964,
	rtl-optimization/31691, target/31022, target/31480, target/31701,
	target/31876, target/32163, tree-optimization/26998, c++/30016,
	c++/30221, middle-end/30761, target/18989, target/28675,
	tree-optimization/29446, tree-optimization/31698, middle-end/31448,
	preprocessor/30468, target/28623, target/31641, c++/30168, c++/31074,
	c++/31449, c++/31517, c/31520, middle-end/30729, target/25448,
	target/30289, target/30483, target/31361, target/31582,
	testsuite/31578, target/31137, target/31380, fortran/31184,
	target/31245, tree-optimization/30590, debug/29906, middle-end/30364,
	middle-end/30433, target/31123, c++/30852, c++/30895,
	fortran/29441, fortran/30400, libgcj/17002,
	libgfortran/30910, libgfortran/30918, other/31050,
	rtl-optimization/30931, target/30848, tree-optimization/29925,
	ada/30684, fortran/30478, fortran/30799, middle-end/24427,
	other/27843, rtl-optimization/28173, rtl-optimization/28772,
	rtl-optimization/29599, rtl-optimization/30787, target/19087,
	tree-optimization/30823, fortran/24783, testsuite/30649,
	middle-end/30313, c++/29487, target/29487, target/30370,
	c++/28988, fortran/30278, libstdc++/30586, middle-end/29683,
	objc/27438, c++/28999, libgfortran/30435, objc/30479,
	rtl-optimization/29329, target/30173, testsuite/12325, target/24036
  - reenable memory CSE (Alexandre Oliva, #229366, PR rtl-optimization/30643)
- backported OpenMP fixes from trunk and gcc-4_2-branch
  - PRs middle-end/32362, tree-optimization/31769, c++/32177, c++/30703,
	middle-end/27416, middle-end/30421, middle-end/30494
  - fix ICE with OpenMP and exceptions (#238399, PR tree-optimization/30558)
- on ppc{,64} when tuning for power6{,x}, try to put the base
  register as first operand in instructions to improve
  performance (Peter Bergner, #225425, PR middle-end/28690)
- fix OpenMP handling of Fortran POINTER non-array vars (PR fortran/32550)
- fix java.utils.logging.Logger (Mark Wielaard, #235371)

* Thu Mar  1 2007 Jakub Jelinek  <jakub@redhat.com> 4.1.1-53.EL4
- add gnu.java.util.ZoneInfo class, use tzdata files for libgcj
  timezone stuff instead of builtin simple and outdated rules (#227983)

* Fri Feb  9 2007 Jakub Jelinek  <jakub@redhat.com> 4.1.1-52.EL4
- regenerate libjava.util.TimeZone data from tzdata2007a (#227983)

* Mon Jan 29 2007 Jakub Jelinek  <jakub@redhat.com> 4.1.1-51.EL4
- update from redhat/gcc-4_1-branch (#200825)
  - fix gfortran -fno-automatic (#203928, PR fortran/28415)

* Mon May 15 2006 Jakub Jelinek  <jakub@redhat.com> 4.1.0-18.EL4
- update from redhat/gcc-4_1-branch

* Tue May  9 2006 Jakub Jelinek  <jakub@redhat.com> 4.1.0-15.EL4
- update from redhat/gcc-4_1-branch
  - fix Java class layout bug (Tom Tromey, #185553, PR java/26042)
  - fix SSE extraction on i?86/x86_64 (Alexandre Oliva, #187450)

* Tue Apr 11 2006 Jakub Jelinek  <jakub@redhat.com> 4.1.0-7.EL4
- update to 4.1.0-RH technology preview (#183083)
  - OpenMP 2.5 support (#181532)
  - Intel MNI intrinsics (#183155)
  - on i?86/x86_64 -mtune=generic support, set by default (#186968, #186973)
  - 64-bit SSE3 intrinsics support (#186975)

* Fri Jan  6 2006 Jakub Jelinek  <jakub@redhat.com> 4.0.2-14.EL4
- fix frame base in debuginfo on IA-64 (Jim Wilson, #176182, PR debug/24444)

* Tue Dec 13 2005 Jakub Jelinek  <jakub@redhat.com> 4.0.2-13.EL4
- fix Java ICE on initialized static final var used in case
  (Andrew Haley, #175569)

* Mon Dec 12 2005 Jakub Jelinek  <jakub@redhat.com> 4.0.2-12.EL4
- fix Java ICE with input_filename being unset (Alexandre Oliva, #174912)

* Fri Dec  9 2005 Jakub Jelinek  <jakub@redhat.com> 4.0.2-11.EL4
- fix signatures of anonymous Java class constructors (Tom Tromey, #174912,
  PR java/25283)

* Fri Dec  2 2005 Jakub Jelinek  <jakub@redhat.com> 4.0.2-10.EL4
- fix Java lookup_label (Per Bothner, #174792)
- never use movl for movqi_1 on i386 -Os if memory address isn't
  known to be aligned (PR target/25199)

* Wed Nov 30 2005 Jakub Jelinek  <jakub@redhat.com> 4.0.2-9.EL4
- update from SVN (up to -r107707)
  - GCC 4.0.2 release
  - PRs ada/23593, bootstrap/21268, c++/13377, c++/16171, c++/19004,
	c++/20646, c++/20817, c++/21135, c++/21440, c++/21514, c++/21687,
	c++/21799, c++/22233, c++/22454, c++/22508, c++/22545, c++/23044,
	c++/23089, c++/23099, c++/23139, c++/23167, c++/23191, c++/23219,
	c++/23225, c++/23266, c++/23337, c++/23491, c++/23586, c++/23624,
	c++/23639, c++/23667, c++/23691, c++/23699, c++/23789, c++/23839,
	c++/23841, c++/23842, c++/23896, c++/23914, c++/8271, c++/9782,
	c/18715, c/20187, c/21562, c/22061, c/22311, c/22458, c/22589,
	c/23106, c/23161, c/23165, c/23506, debug/20161, debug/20998,
	debug/23190, debug/23806, fortran/16511, fortran/17917, fortran/18870,
	fortran/18878, fortran/19358, fortran/20363, fortran/20848,
	fortran/21432, fortran/22010, fortran/22304, fortran/22502,
	fortran/23065, fortran/23270, fortran/23661, fortran/23765,
	java/17845, java/21436, java/23230, libffi/21819, libfortran/15266,
	libfortran/19872, libfortran/22143, libfortran/23154,
	libfortran/23178, libfortran/23262, libfortran/23419,
	libfortran/23428, libfortran/23598, libfortran/23784, libgcj/21020,
	libgcj/21074, libgcj/21943, libgcj/22211, libgcj/23353, libgcj/23508,
	libgcj/23549, libgcj/23662, libgcj/23739, libobjc/23108,
	libstdc++/23081, libstdc++/23358, libstdc++/23417, libstdc++/23465,
	libstdc++/23550, middle-end/20109, middle-end/20624, middle-end/21291,
	middle-end/21309, middle-end/21362, middle-end/21460,
	middle-end/21529, middle-end/21728, middle-end/21894,
	middle-end/21964, middle-end/22439, middle-end/23221,
	middle-end/23312, middle-end/23369, middle-end/23517,
	middle-end/25120, preprocessor/20348, preprocessor/20356,
	rtl-opt/22619, rtl-optimization/15248, rtl-optimization/21254,
	rtl-optimization/23241, rtl-optimization/23454, target/17692,
	target/18582, target/19885, target/20621, target/20673, target/20799,
	target/21571, target/21723, target/21841, target/23070, target/23250,
	target/23309, target/23404, target/23539, target/23556, target/23575,
	target/23630, target/23747, target/23774, testsuite/23607,
	tree-optimization/15366, tree-optimization/19899,
	tree-optimization/21105, tree-optimization/22348,
	tree-optimization/23192, tree-optimization/23326,
	tree-optimization/23426, tree-optimization/23546
  - fix Java inner class handling (Ranjit Mathew, Tom Tromey, #167342,
    PRs java/20338, java/19870, java/21844)
  - add -fno-automatic support for gfortran (Francois-Xavier Coudert,
    PR fortran/20592, #168355, IT#79774)
  - fix gfortran -fno-automatic with explicit SAVE attributes or statements
    (PR fortran/23677, #168355, IT#79774)
  - fix reads beyond EOF in libfortran (Thomas Koenig, #170543, IT#79588,
    PR libfortran/23321)
  - check fortran ACCESS= parameter to OPEN (#173932)
  - fix Java class lookup (#174310)
  - fix _Jv_Condwait (Andrew Haley, #161483, libgcj/25016)
  - fix libstdc++ ostream oct and hex formatting logic
    (Paolo Carlini, Janis Johnson, #168205, PR libstdc++/23871)
  - fix fortran ENTRY handling when ENTRY symbol is passed
    to a function (PR fortran/23663)
  - make sure dominance info is computed in stdarg pass
    (PR tree-optimization/23818)
  - workaround for stack smashing in Java's fdlibm
    (Tom Tromey, #166657, PR classpath/23863)
  - fix libgfortran Tn format handling (#166480)
  - fix DW_AT_encoding of const char (#167148, PR debug/7241)
  - fix ia64 profiling (Richard Henderson, PR target/12455)
  - delegitimize PIC addresses in a few extra places
    (PR rtl-optimization/23098)
  - fix constant sharing bug in static_cast handling (PR c++/23056)
  - avoid redundant warnings on return; in function returning non-void
    (PR c/23075)
  - avoid duplicate no unique final overrider error messages (PR c++/21983)
  - when deciding about i?86 calling conventions for local functions,
    take into account global register variables (PR target/22362)
  - avoid call used regs for pseudos that live across calls that may throw
    (#166237, PR rtl-optimization/23478)
  - fix stringbuf in_avail() (Benjamin Kosnik, #159408, IT#72781,
    PR libstdc++/21955)
  - fix strength reduction (Richard Henderson, #166353, PR rtl-opt/23560)
  - allow string and memory builtins to overflow from one structure field
    into another one (#166707, PR rtl-optimization/23561)
  - fix DW_AT_frame_base attribute computation and handling of locations based
    on the frame base (Richard Henderson, #165514)
  - fix __builtin_*_chk miscompilation (PR middle-end/23484)
  - fix -dv option handling (#165627)
  - emit DWARF3 DW_AT_call_file and DW_AT_call_line attributes for inlines
    (Jim Wilson)
  - improve debug info for inlined functions (Jim Wilson, PR debug/20268)
  - fix hoisting to basic blocks ending with possibly throwing call
    whose some hard register arg setups have been CSEd out
    (Dale Johannesen, #163195, PR rtl-optimization/23299)
  - use DW_OP_fbreg where possible (#165514)
  - prefer var tracking gathered locations even if they are the same
    throughout the whole function (#165514)
  - use DWARF3 DW_CFA_offset_extended_sf instead of obsolete
    DW_CFA_GNU_negative_offset_extended in libffi handwritten assembly
    on ppc (#165039)
  - add testcase for ppc32 problem with .got2 relocs against discarded
    sections (PR target/17828)

* Thu Aug 11 2005 Jakub Jelinek  <jakub@redhat.com> 4.0.1-4.EL4.2
- fix a build problem when gcc-c++-3.4.4-2 or later is installed
- add BuildRequires for gcc-c++

* Fri Jul 29 2005 Jakub Jelinek  <jakub@redhat.com> 4.0.1-4.EL4.1
- fix libstdc++.so symlinks to play well together with gcc-3.4.4-2
  and above

* Wed Jul 27 2005 Jakub Jelinek  <jakub@redhat.com> 4.0.1-4.EL4
- update from CVS
  - GCC 4.0.1 release
  - PRs bootstrap/17383, bootstrap/20633, bootstrap/21215, bootstrap/21230,
	bootstrap/21403, bootstrap/21704, c++/1016, c++/10611, c++/15875,
	c++/19203, c++/19542, c++/20145, c++/20212, c++/20350, c++/20563,
	c++/20637, c++/20678, c++/20723, c++/20746, c++/20789, c++/20905,
	c++/20961, c++/21025, c++/21087, c++/21151, c++/21165, c++/21280,
	c++/21336, c++/21340, c++/21352, c++/21454, c++/21455, c++/21495,
	c++/21614, c++/21619, c++/21681, c++/21686, c++/21768, c++/21784,
	c++/21853, c++/21903, c++/21929, c++/22132, c++/22139, c++/22263,
	c/12913, c/15698, c/20740, c/20760, c/21159, c/21160, c/21213,
	c/21342, c/21502, c/21536, c/21873, c/21879, c/21911, c/22308,
	c/22421, debug/21828, fortran/13257, fortran/14569, fortran/15080,
	fortran/15959, fortran/15966, fortran/16531, fortran/16861,
	fortran/16898, fortran/16939, fortran/16940, fortran/17143,
	fortran/17192, fortran/17193, fortran/17202, fortran/17229,
	fortran/17432, fortran/17792, fortran/18109, fortran/18283,
	fortran/18689, fortran/18781, fortran/18890, fortran/19107,
	fortran/19195, fortran/19478, fortran/19926, fortran/20059,
	fortran/20713, fortran/20842, fortran/20846, fortran/20865,
	fortran/20879, fortran/20883, fortran/20954, fortran/21034,
	fortran/21177, fortran/21257, fortran/21260, fortran/21375,
	fortran/21912, fortran/22038, fortran/22327, fortran/22417,
	fortran/14569, java/19285, java/20309, java/20768, java/21022,
	java/21115, java/21519, java/21722, libffi/21285, libfortran/16435,
	libfortran/16436, libfortran/17283, libfortran/17992,
	libfortran/18495, libfortran/18857, libfortran/18958,
	libfortran/19014, libfortran/19016, libfortran/19106,
	libfortran/19155, libfortran/19216, libfortran/19568,
	libfortran/19595, libfortran/20005, libfortran/20006,
	libfortran/20074, libfortran/20092, libfortran/20131,
	libfortran/20163, libfortran/20179, libfortran/20436,
	libfortran/20661, libfortran/20744, libfortran/20766,
	libfortran/20788, libfortran/20930, libfortran/20950,
	libfortran/21075, libfortran/21108, libfortran/21127,
	libfortran/21324, libfortran/21333, libfortran/21354,
	libfortran/21376, libfortran/21471, libfortran/21480,
	libfortran/21593, libfortran/21594, libfortran/21875,
	libfortran/21926, libfortran/21950, libfortran/22142,
	libfortran/22144, libfortran/22412, libfortran/22570, libgcj/18220,
	libgcj/19729, libgcj/20273, libgcj/20504, libgcj/20693,
	libgcj/21136, libgcj/21140, libgcj/21233, libgcj/21372,
	libgcj/21557, libgcj/21606, libgcj/21637, libgcj/21703,
	libgcj/21736, libgcj/21753, libgcj/21775, libstdc++/18604,
	libstdc++/20806, libstdc++/20909, libstdc++/20914, libstdc++/21035,
	libstdc++/21131, libstdc++/21193, libstdc++/21209, libstdc++/21238,
	libstdc++/21244, libstdc++/21286, libstdc++/21526, libstdc++/21726,
	libstdc++/22102, libstdc++/22109, libstdc++/22111, libstdc++/23053,
	middle-end/16719, middle-end/17961, middle-end/18421,
	middle-end/19985, middle-end/20593, middle-end/20648,
	middle-end/20739, middle-end/20917, middle-end/20931,
	middle-end/20946, middle-end/20973, middle-end/20991,
	middle-end/21085, middle-end/21237, middle-end/21265,
	middle-end/21595, middle-end/21850, middle-end/21985,
	middle-end/22028, middle-end/22057, other/21052, preprocessor/20907,
	regression/21897, rtl-opt/21102, rtl-opt/21163, rtl-opt/21528,
	rtl-optimization/21144, rtl-optimization/21239,
	rtl-optimization/21330, rtl-optimization/22167, target/16888,
	target/16925, target/17245, target/17822, target/17824,
	target/18655, target/19051, target/19933, target/20093,
	target/20301, target/20375, target/20795, target/20924,
	target/20927, target/21098, target/21099, target/21100,
	target/21101, target/21149, target/21284, target/21297,
	target/21315, target/21325, target/21329, target/21390,
	target/21397, target/21412, target/21416, target/21551,
	target/21556, target/21657, target/21721, target/21888,
	target/21889, target/22083, target/22260, target/22576,
	testsuite/21969, tree-opt/19768, tree-opt/22105,
	tree-optimization/20490, tree-optimization/20929,
	tree-optimization/21085, tree-optimization/21167,
	tree-optimization/21171, tree-optimization/21173,
	tree-optimization/21380, tree-optimization/21532,
	tree-optimization/21817, tree-optimization/21847,
	tree-optimization/22000, tree-optimization/22043,
	tree-optimization/22171, tree-optimization/22591, treelang/21345
  - fix fortran handling of repeated character literals in DATA (#163394,
    PR fortran/20063)
  - avoid sibling calls if structure arguments passed by value overlap
    (#163058)
  - avoid discarding volatile casts (Richard Henderson, #162274,
    PR tree-opt/22278)
  - fix -frepo (Mark Mitchell, #163271, PR c++/22204)
  - use SCHED_OTHER rather than SCHED_RR in libjava (Andrew Haley, #152386)
  - fix compound literal handling (Joseph S. Myers, #160018, c/22013, c/22098)
  - fix -march=i386 -masm=intel -fpic (#162585)
  - accept fortran ENTRY without () even in FUNCTIONs (#161634)
  - fix fortran handling of ENTRY return var names as rvalues (#161669)
  - fix fortran ICE on invalid preprocessor line (#161679)
  - fix fortran handling of long preprocessor lines (#161680)
  - fortran Hollerith constant and character array fixes (Feng Wang, #161430)
  - fix reg-stack ICE (#158407, PR target/21716)
  - fix ICE on fortran alternate returns (#158434)
  - fix ICE on fortran functions without explicit type with implicit none
    (#158232, PR fortran/21729)
  - fix overflowed constant handling (Zdenek Dvorak, #156844,
    PRs middle-end/21331, tree-opt/21293)
  - fix IA-64 ICE on sdata/sbss variable references with offsets
    (Richard Henderson, #158001, PR target/21632)
  - fix german, spanish, turkish and chinese translations (#157879,
    PR translation/21364)
  - fixed WHERE inside FORALL (PR fortran/15080)
  - fix a tree sharing bug (#157792, PR tree-optimization/21610)
  - avoid using hash tables recursively (#157308)
  - fix ppc64 libgcj (Andrew Haley, #154684, #142611)
  - fix crossjumping (#157243, PR middle-end/21492)
  - fix i386 V4SFmode vector initialization
  - https Handler.java from GNU classpath (Thomas Fitzsimmons, #155466)
  - Fortran namelist support (Paul Thomas, #155852, PRs fortran/17472,
    fortran/18396, fortran/19467, libfortran/12884, libfortran/17285,
    libfortran/18122, libfortran/18209, libfortran/18210, libfortran/18392,
    libfortran/18591, libfortran/18879, libfortran/19657)
  - fixes for the Fortran ENTRY support (PRs fortran/13082,
    fortran/18824, #153715)
  - fix GThread errors when running OOo (Thomas Fitzsimmons, #154215)
  - fix dwarf2 writer to avoid ICEing gdb (Jim Wilson, #153681, PR c++/20805)
  - fix hang in tree-chrec.c (Sebastian Pop, #153268, PR tree-optimization/20742)
  - fix KDE miscompilation caused by reload (Michael Matz, #154294,
    PR regression/20973)
  - add support for Fortran ENTRY in FUNCTIONS and SUBROUTINES with alternate
    returns (PRs fortran/13082, fortran/18824, #153715)
- fix fortran EQUIVALENCE handling with substrings (#160853,
  PRs fortran/18833, fortran/20850)
- improve fortran diagnostics for comparison of logicals (Volker Reichelt,
  PR fortran/22503)
- work around PR middle-end/20606 (Andrew Haley)
- diagnose invalid uses of inline (Eric Christopher, #162216, #159731,
  PRs c/22052, c/21975)
- fix linker command line ordering when compiling multiple
  java source files (Tom Tromey, #163099)
- use backtrace () in libgcj even on ia64
- support more than 16 nested GCC visibility pragmas (H.J.Lu)
- make sure libstdc++ mt allocator calls pthread_key_delete before
  libstdc++ dlclose (#161061, PR libstdc++/22309)
- fix ICE when compiling call with excessive size of arguments
  passed by value (#160718, PR middle-end/17965)
- grmic fix (Archit Shah, #133180)
- make libltdl aware of */lib64 paths (#156005)
- make sure slow_pthread_self is never yes for linux targets
- rename libjawt.so* to libgcjawt.so* to avoid interferences
  with proprietary libjawt.so's
- add gjnih4 to gcc4-java subpackage
- configure with --enable-libgcj-multifile to avoid make -jN
  related multilib failures
- use INTERNAL_SYSCALL* macros in libgcc_post_upgrade.c, so that the
  statically linked binary doesn't need TLS (#155701)
- implement java.awt.Frame.getBufferStrategy (Thomas Fitzsimmons, #153266)
- configure with
  --with-java-home=%{_prefix}/lib/jvm/java-1.4.2-gcj-1.4.2.0/jre
- include empty %{_prefix}/share/java/gcj-endorsed and
  %{_prefix}/%{_lib}/gcj-%{version}/classmap.db.d directories and
  %%ghost %{_prefix}/%{_lib}/gcj-%{version}/classmap.db

* Wed Apr  6 2005 Jakub Jelinek  <jakub@redhat.com> 4.0.0-0.41.fc3
- update from CVS
  - PRs c++/19312, c++/20734, libgcj/20750, middle-end/19225, target/20342,
	target/20421, target/20447, target/20625, target/20670, ada/19956,
	c++/18644, c++/19159, c++/19199, c++/20679, debug/20505,
	libfortran/20068, libfortran/20125, libfortran/20156,
	libfortran/20471, libfortran/20755, libgcj/20727, libgcj/20761,
	rtl-optimization/16104, rtl-optimization/20527, target/19537,
	target/20446, tree-optimization/19903, c++/19406, c/17855, c/17913,
	c/20368, c/20519, c/772, debug/19345, libfortran/20660, libgcj/20090,
	libgcj/20526, middle-end/19454, middle-end/20177, middle-end/20635,
	rtl-optimization/20600, target/20203, target/20611,
	libfortran/15332, libfortran/19678, libfortran/19679,
	libfortran/20163, middle-end/20263, middle-end/20491,
	rtl-optimization/20249, target/15491, target/20617, tree-opt/19108,
	tree-optimization/19108, middle-end/20622, c++/19769, c++/19980,
	c++/20147, c++/20147, c++/20461, c++/20463, c++/20465, c++/20499,
	c++/20536, libfortran/18025, libgcj/11085, libgcj/14892, libgcj/18083,
	libgcj/2641, libgcj/9854, libstdc++/20352, libstdc++/20577,
	middle-end/20539, middle-end/20557, other/20564, target/20166,
	target/20561, rtl-optimization/20532, ada/18727, ada/19140, ada/19408,
	ada/19900, ada/20255, ada/20344, c++/20240, c++/20333, fortran/18525,
	fortran/18827, java/20522, libfortran/20257, libfortran/20480,
	libgcj/20251, middle-end/15700, middle-end/20225, middle-end/20493,
	target/18251, target/18380, target/18551, tree-optimization/17454,
	tree-optimization/20474, preprocessor/19475, tree-optimization/20076
  - fixed ABI bug where __attribute was ignored on certain struct
    fields (Mark Mitchell, PR c++/20763)
  - fix edge redirection (Alexandre Oliva, #152149,
    PR tree-optimization/20640)
  - fix PRE causing miscompilation of sudo (Daniel Berlin, #151632,
    PR tree-optimization/20601)
  - fix loop optimizer with loops that after tree optimization are entered
    after the loop body (Alexandre Oliva, PR rtl-optimization/20290, #150020)
  - fix handling of jump tables at the end of scope with -g1 (#151466)
- add g++.dg/compat/struct-layout-1.exp compatibility tests
- remove very old ChangeLogs from %%doc, bzip2 all ChangeLogs to
  save space
- BuildRequire gmp-devel with mpfr support
- revert (just for gcc4-4*, not gcc-4*) PR libstdc++10606 patch, so that
  GCC 3.4.3-RH libstdc++ can be used (#151462)

* Tue Mar 15 2005 Jakub Jelinek  <jakub@redhat.com> 4.0.0-0.34.fc3
- update from gcc-4_0-branch
  - PRs c++/20157, c++/20280, fortran/16907, fortran/20323, fortran/20361,
        fortran/20467, libfortran/20124, middle-end/19331, other/20326,
        rtl-optimization/20306, target/20288, target/20415,
	c++/20142, c++/20186, c++/20208, c++/20375, libgcj/20389,
        rtl-opt/20412, ada/20035, c++/19311, c++/19797, debug/20253,
	fortran/19673, fortran/19754, fortran/19936, java/18362, java/20215,
        libgcj/20155, libgcj/20292, rtl-optimization/19683,
        target/20277, tree-optimization/18815, tree-optimization/20122,
	c++/18327, c++/18384, c++/20232, fortran/19479,
        libgcj/20160, libobjc/19024, rtl-optimization/17728,
        target/19065, target/19819, tree-optimization/20216
  - fixed PR c++/19916 (Mark Mitchell, #148793)
  - fixed (Alexandre Oliva, #149098)
  - fix s390* reload issue (Ulrich Weigand, #150115)
- fix CSE on hard registers with different modes (Zdenek Dvorak, #150115,
  PR middle-end/20249)
- fix PR middle-end/18628 (Alexandre Oliva)
- fix miscompilation of python (Alexandre Oliva, PR target/20126)
- fix ICE when taking address of a member function in template
  (Kriang Lerdsuwanakij, PR c++/20381)
- fix handling of in/out asm constraints with multiple alternatives
  (#150202, PR inline-asm/20314)
- fix miscompilation of libcpp.a on x86-64 (PR target/20322)
- with CSE handling of TABLEJUMPs (Alexendre Oliva, PR middle-end/18628)
- revert PR c++/16405 fix to fix PR c++/19317 (Qt miscompilation)
- fix libcpp, so that it can be compiled by GCC4 on 64-bit
  big-endian architectures (PRs bootstrap/20282, bootstrap/20305)
- fix -fno-unit-at-a-time handling of static functions with
  global aliases (Alexandre Oliva, #150150)

* Thu Feb 24 2005 Jakub Jelinek  <jakub@redhat.com> 4.0.0-0.29
- fix -Wmissing-braces in C++ (PR c++/20175)
- fix PowerPC sCC splitters (PR target/20196)

* Wed Feb 23 2005 Jakub Jelinek  <jakub@redhat.com> 4.0.0-0.28
- update from trunk
  - rename PowerPC IBM long double helper routines _xlq* to __gcc_*,
    but keep _xlq*@GCC_3.4 aliases around (#148841, PR target/19019)
  - make sure libjava GC memory is executable for libffi trampolines sake
    (#149348, PR libgcj/19823)
  - remove java abstract method check (#147968)
  - change __cxa_demangle to match cxx-abi change
    http://www.codesourcery.com/archives/cxx-abi-dev/msg01877.html
    (Jason Merrill, #133406)
- fix ivopts (Zdenek Dvorak, PR tree-optimization/19937)
- workaround ia64 BImode issues (Roger Sayle, PRs target/20018,
  rtl-optimization/20097)

* Fri Feb 18 2005 Jakub Jelinek  <jakub@redhat.com> 4.0.0-0.27
- fix PRs c++/20008, target/20054
- fix PR tree-optimization/19828 (#149058)

* Thu Feb 17 2005 Jakub Jelinek  <jakub@redhat.com> 4.0.0-0.26
- update from trunk
- fix PRs c++/20023, tree-optimization/20009

* Wed Feb 16 2005 Jakub Jelinek  <jakub@redhat.com> 4.0.0-0.25
- fix PR c++/19813

* Wed Feb 16 2005 Jakub Jelinek  <jakub@redhat.com> 4.0.0-0.24
- update from trunk
- fix PRs middle-end/19857, tree-optimization/18947
- work around PR debug/19769

* Thu Feb 10 2005 Jakub Jelinek  <jakub@redhat.com> 4.0.0-0.23
- update from trunk
- in gcc4-java, require exact %%{version}-%%{release} of libgcj4 and
  libgcj4-devel (#146271)
- make sure libgcj.so is not PT_GNU_STACK RWE
- on i?86 with -mfpmath=sse, optimize static routines whose address
  is never taken and don't use __attribute((used)) by passing some floating
  point arguments and return value in SSE registers
- add libgcj4-src subpackage
- fix PR middle-end/19858
- use crtendS.o instead of crtend.o on ppc -pie

* Tue Jan 25 2005 Jakub Jelinek  <jakub@redhat.com> 4.0.0-0.22
- update from trunk
- fix PR rtl-optimization/19579
- remove Java *.a libraries, issue error for gcj -static (#145829)

* Sat Jan 22 2005 Jakub Jelinek  <jakub@redhat.com> 4.0.0-0.21
- update from trunk
- fix PRs middle-end/19551, c/18946, c/19342
- allow REFERENCE_TYPEs in place of POINTER_TYPEs in builtins.c

* Tue Jan 18 2005 Jakub Jelinek  <jakub@redhat.com> 4.0.0-0.20
- update from trunk
- fix PR c++/19406

* Thu Jan 13 2005 Jakub Jelinek  <jakub@redhat.com> 4.0.0-0.19
- update from trunk
- fix PRs c++/19263, rtl-optimization/16104, c/17297, middle-end/19164,
	  rtl-optimization/15139, rtl-optimization/19348, middle-end/19084

* Thu Jan  6 2005 Jakub Jelinek  <jakub@redhat.com> 4.0.0-0.18
- update from trunk
- fix PRs tree-optimization/19060, rtl-optimization/18861,
	  tree-optimization/18828, rtl-optimization/19012,
	  tree-optimization/19283

* Fri Dec 31 2004 Jakub Jelinek  <jakub@redhat.com> 4.0.0-0.17
- fix build of libgij.so (#143862)
- remove libgcj.pc
- fix ICE in reshape_init_array (#143034, PRs c++/18384, c++/18327)

* Tue Dec 28 2004 Jakub Jelinek  <jakub@redhat.com> 4.0.0-0.16
- update from trunk
- include also gcc4-java, libgcj4 and libgcj4-devel subpackages

* Tue Dec 14 2004 Jakub Jelinek  <jakub@redhat.com> 4.0.0-0.14.EL4
- update from trunk
  - fix tree inlining related ICE (Alexandre Oliva, #141145)
- avoid multiple evaluation of sqrt and other math builtins when
  not -ffast-math (#142603, PR middle-end/18951)

* Tue Dec  7 2004 Jakub Jelinek  <jakub@redhat.com> 4.0.0-0.14
- update from trunk
  - fix DEPENDENCIES_OUTPUT handling (#140921)
- fix libstdc++.so symlinks (#141985)
- make sure target's LOAD_EXTEND_OP or lack thereof doesn't influence
  gcj -C output (#141730)

* Sat Nov 27 2004 Jakub Jelinek  <jakub@redhat.com> 4.0.0-0.13
- update from trunk
  - change s390{,x} stack layout to work-around GCC 2.95.3 bug:
    former -mno-backchain (the default), -mbackchain and -mkernel-backchain
    options were transformed into (in order) -mno-backchain -mpacked-stack,
    -mbackchain -mno-packed-stack and -mbackchain -mpacked-stack.
    A new combination -mno-backchain -mno-packed-stack is now the
    new default (Andreas Krebbel, #139678)
- don't optimize printf/fprintf/__printf_chk/__fprintf_chk in any way
  if return value is not ignored
- some more libgcc_s.so.1 tweaks on ia64

* Fri Nov 12 2004 Jakub Jelinek  <jakub@redhat.com> 4.0.0-0.12
- update from trunk
- make _Unwind_* symbols in libgcc_s.so.1 unversioned to match the
  "IA-64 Linux ABI"

* Mon Nov  8 2004 Jakub Jelinek  <jakub@redhat.com> 4.0.0-0.11
- use/require GCC 3.4.3 instead of 3.4.2

* Sun Nov  7 2004 Jakub Jelinek  <jakub@redhat.com> 4.0.0-0.10
- update from trunk
- add %%doc COPYING and COPYING.LIB

* Thu Oct 28 2004 Jakub Jelinek  <jakub@redhat.com> 4.0.0-0.9
- update from trunk
- run testsuite with LC_ALL=C

* Tue Oct 19 2004 Jakub Jelinek  <jakub@redhat.com> 4.0.0-0.8
- update from trunk
- make sure .toc{,1} sections are created on ppc -m64 -mminimal-toc
  (#134248, PR target/17751)
- define __GNUC_RH_RELEASE__ macro to match %%{gcc_release} rpm macro
  (well, its first number)

* Sat Oct 16 2004 Jakub Jelinek  <jakub@redhat.com> 4.0.0-0.7
- added object size checking patch
- added stdarg optimization patch

* Sat Oct 16 2004 Jakub Jelinek  <jakub@redhat.com> 4.0.0-0.6
- update from trunk

* Fri Oct  8 2004 Jakub Jelinek  <jakub@redhat.com> 4.0.0-0.5
- update from trunk
  - fix ppc64 bootstrap (Michael Matz)

* Fri Oct  8 2004 Jakub Jelinek  <jakub@redhat.com> 4.0.0-0.4
- update from trunk
- call /sbin/ldconfig in libgfortran and libmudflap %%post{,un} (#134067)
- obsolete gcc35-gfortran (#134810)
- re-enable COMDAT

* Tue Sep 28 2004 Jakub Jelinek  <jakub@redhat.com> 4.0.0-0.3
- update from trunk

* Mon Sep 20 2004 Jakub Jelinek  <jakub@redhat.com> 4.0.0-0.2
- update from trunk
- add .note.GNU-stack marking to ppc64 crtsavres.o and
  ia64 crt{begin,end,i,n}.o
- gimplify folded builtins during fold_all_builtins pass
  if they aren't gimple
- use/require GCC 3.4.2 instead of 3.4.1

* Fri Sep 17 2004 Jakub Jelinek  <jakub@redhat.com> 4.0.0-0.1
- update from trunk
- change version to 4.0.0, as there will be no GCC 3.5
- temporarily disable COMDAT support until at least binutils are upgraded
- temporarily remove the IA-64 libunwind stuff

* Thu Sep  9 2004 Jakub Jelinek  <jakub@redhat.com> 3.5.0-0.11
- improve SSA aliasing detection for PTR + OFFSET

* Wed Sep  1 2004 Jakub Jelinek  <jakub@redhat.com> 3.5.0-0.10
- update from trunk
- fix x ? (unsigned long) d : (long) d conversion bug for d floating
  (#131082)

* Fri Aug 20 2004 Jakub Jelinek  <jakub@redhat.com> 3.5.0-0.9
- fix ppc64 bootstrap (PR rtl-optimization/17099)
- fix libstdc++.so symlinks, include libsupc++.a everywhere
- remove Fortran documentation which accidentally ended up in
  libmudflap-devel, add libmudflap ChangeLog
- add spe.h header on ppc and ppc64, altivec.h and ppc-asm.h on ppc64

* Wed Aug 18 2004 Jakub Jelinek  <jakub@redhat.com> 3.5.0-0.8
- update from trunk
- stop using dot symbols on ppc64 (Alan Modra)
- overlap fd_aux field of ppc64 .opd entries with next .opd entry's fd_func
  if a function is not going to use r11 passed to it
- add mm3dnow.h and mm_malloc.h headers on ia32/x86-64
- add gcc35-gfortran, libgfortran subpackages (#130212)
- add libmudflap and libmudflap-devel subpackages

* Thu Jul 15 2004 Jakub Jelinek  <jakub@redhat.com> 3.5.0-0.7
- update from trunk
- make even multilib libstdc++.so's versioned

* Fri Jul  9 2004 Jakub Jelinek  <jakub@redhat.com> 3.5.0-0.6
- reenable bitfield patch
- fix enum { A, B, C, D, E } if (x == B || x == C || x == D)
  style tests in C++

* Fri Jul  9 2004 Jakub Jelinek  <jakub@redhat.com> 3.5.0-0.5
- update from trunk

* Mon Jul  5 2004 Jakub Jelinek  <jakub@redhat.com> 3.5.0-0.4
- temporary disable the bitfield patch until it is fixed

* Sat Jul  3 2004 Jakub Jelinek  <jakub@redhat.com> 3.5.0-0.3
- update from trunk
- use/require gcc 3.4.1 instead of 3.4.0

* Tue Jun 29 2004 Jakub Jelinek  <jakub@redhat.com> 3.5.0-0.2
- optimize some bitfield operations (PR tree-optimization/15310)

* Thu Jun 24 2004 Jakub Jelinek  <jakub@redhat.com> 3.5.0-0.1
- initial package
